
// "PRIVATE" Routines  -  These will be very specific to a plugin, and include "secret" routines.

// Macintosh Ethernet routines based largely on examples from Rich Kubota



#if FM_CPU_X86
static void BlockMoveData(const void *source, void *dest, unsigned long amntcpy)
{  // if  amntcpy is less than source (ie doesn't reach /0) then /0 is NOT appended
    // if amntcpy is more than source, /0 is used as padding

memcpy( dest, source, (size_t)amntcpy);

} // BlockMoveData
#endif




static void checkErrResultIgnore (char boolFileResult, int macFerr, FHandle result)
{
unsigned char	tempReturnStr[16];

switch (boolFileResult)
	{
	case -1: // macFerr holds an error, return it!!!
		if (macFerr < 0)
			{
			macFerr *= -1;
			tempReturnStr[1] = '-';
			convertUInt32toStr (0, (unsigned long)macFerr, &(tempReturnStr[2]), &(tempReturnStr[0]), 0);
			tempReturnStr[0] = (unsigned char)(tempReturnStr[0] + 1);
			}
			else
			{
			convertUInt32toStr (0, (unsigned long)macFerr, &(tempReturnStr[1]), &(tempReturnStr[0]), 0);
			};

		FMX_SetHandleSize(result, tempReturnStr[0]);
		if (FMX_MemoryError() == 0) 
		{
				BlockMoveData(tempReturnStr+1, *result, tempReturnStr[0]);
		};
		break;
	
	default:  // result holds valid data, so DON'T TOUCH IT!!!
		break;
		
	}; //  (boolFileResult)
} // checkErrResultIgnore



static void checkErrResult (char boolFileResult, int macFerr, FHandle result)
{
unsigned char	tempReturnStr[16];

switch (boolFileResult)
	{
	case -1: // macFerr holds an error, return it!!!
		if (macFerr < 0)
			{
			macFerr *= -1;
			tempReturnStr[1] = '-';
			
			convertUInt32toStr (0, (unsigned long)macFerr, &(tempReturnStr[2]), &(tempReturnStr[0]), 0);			
			tempReturnStr[0] = (unsigned char)(tempReturnStr[0] + 1);
			}
			else
			{
			convertUInt32toStr (0, (unsigned long)macFerr, &(tempReturnStr[1]), &(tempReturnStr[0]), 0);
			};
		break;
	
	default:  // function did it's job, result needs to be "1" or (boolFileResult) so make it so!!  = )
		tempReturnStr[0] = 1;
		tempReturnStr[1] = (unsigned char)('0'+ boolFileResult);
		break;
		
	}; //  (boolFileResult)
	
FMX_SetHandleSize(result, tempReturnStr[0]);
if (FMX_MemoryError() == 0) 
{
		BlockMoveData(tempReturnStr+1, *result, tempReturnStr[0]);
};

} // checkErrResult







static unsigned char threeChToOneCh (unsigned char c1, unsigned char c2, unsigned char c3)
{
unsigned char realC;

realC = 0;

if ((c1 >= '0') && (c1 <= '2')) // Xyz,  X can only be 0,1,2...
	{			
		realC += 100 * (c1 - '0');
	};
	
if (c1 >= '2') // 2xy means that x can only be 0-5
	{
		if ((c2 >= '0') && (c2 <= '5'))
			{			
				realC += 10 * (c2 - '0');
			};
	}
	else
	{
		if ((c2 >= '0') && (c2 <= '9'))
			{			
				realC += 10 * (c2 - '0');
			};
	};


if ((c1 >= '2') && (c2 >= '5'))  // 25x means x can only be 0-5....
	{
		if ((c3 >= '0') && (c3 <= '5'))
			{			
				realC += (c3 - '0');
			};
	}
	else
	{
		if ((c3 >= '0') && (c3 <= '9'))
			{			
				realC += (c3 - '0');
			};
	};

	
return (realC);
} // threeChToOneCh



static unsigned long quickPower (unsigned long theBase, unsigned long toThePower)
{
unsigned long thisPower;
unsigned long returnThisPowered;

returnThisPowered = 0;
thisPower = 0;

if ((toThePower > 0 ) && (toThePower < 100))
	{
		returnThisPowered = theBase;
		for (thisPower = 2; thisPower <= toThePower; thisPower++)
			{
				returnThisPowered *= theBase;
			};
	}
	else
	{
		returnThisPowered = 1;
	};
	
return(returnThisPowered);
} // quickPower





static long strToLong (unsigned char *pasclStr)
{// 4294967296
unsigned char StrLen;  
unsigned char x;
unsigned char xStart;
unsigned char tempCh;
long tempLong;

StrLen = pasclStr[0];
tempLong = 0;

if (pasclStr[1] == '-')
	{
		xStart = 2;
		if (StrLen > 11)
			{
			xStart = (unsigned char)(StrLen - 10);
			};
	}
	else
	{
		xStart = 1;
		if (StrLen > 10)
			{
			xStart = (unsigned char)(StrLen - 10);
			};
	};

for (x = xStart; x <= StrLen; x++)
	{
	tempCh = pasclStr[x];
	if ((tempCh >= '0') && (tempCh <= '9'))
		{
			tempLong *= 10;
			tempLong += (long)(tempCh-'0');
		};
	};
	
if ( pasclStr[1] == '-' )
	{
	tempLong *= -1;
	};
	
return (tempLong);
} // strToLong



static unsigned int fiveChToInt (unsigned char c1, unsigned char c2, unsigned char c3, unsigned char c4, unsigned char c5)
{
unsigned int realInt;

realInt = 0;

if ((c1 >= '0') && (c1 <= '1'))
	{			
		realInt += 10000 * (unsigned int)(c1 - '0');
	};

if ((c1 == '0'))
	{	
	if ( (c2 >= '0') && (c2 <= '9') )
		{			
			realInt += 1000 * (unsigned int)(c2 - '0');
		};
	};
	
if ((c1 == '1'))
	{
	if (  (c2 >= '0') && (c2 <= '6'))
		{			
			realInt += 1000 * (unsigned int)(c2 - '0');
		}
		else
		{
			realInt += 6000;
			c2 = '6';
		};
	};

if ( !((c1 == '1') && (c2 == '6')) )
	{
	if ((c3 >= '0') && (c3 <= '9'))
		{			
			realInt += 100 * (unsigned int)(c3 - '0');
		};
		
	if ((c4 >= '0') && (c4 <= '9'))
		{			
			realInt += 10 * (unsigned int)(c4 - '0');
		};
		
	if ((c5 >= '0') && (c5 <= '9'))
		{			
			realInt += (unsigned int)(c5 - '0');
		};
	};

return (realInt);
} // fiveChToInt



static void getParamByNumber(FHandle complexParameters, short ParamNum, unsigned int maxReturnSize, unsigned char  *paramData, unsigned int *paramSize)
{
// paramData will begin and [1] and end at [size], it's up to you to put *paramSize in [0] 
//      or if it is supposed to be a c-string you must set origin at [-1] instead of [0] and put /0 at [size] 
	long			CPhdlsize;
	unsigned char	*CPchptr;
	unsigned char	CPch;
	unsigned int		sizeOfParam;
	unsigned int		x;
	unsigned int 		gotChars;
	unsigned int		gotReturns;
	unsigned char		gotParam;
	
	gotChars = 0;
	gotReturns = 0;
	gotParam = false;
	sizeOfParam = 0;
	
	CPhdlsize = FMX_GetHandleSize(complexParameters);
	CPchptr = *complexParameters;

	for (x = 0; ( (x <= (CPhdlsize - 1)) && (!gotParam)  && (gotChars <= maxReturnSize)); x++)
		{
		CPch = *(CPchptr+x);
		if ( (gotReturns+1) == ParamNum)
			{
				if (  (CPch == '|') && (gotChars > 0 ) )
					{
						gotParam = true;
						sizeOfParam = gotChars;
						gotChars = 0;
					}
				  else
				  	{
				  		if ( (CPch != '|') )
				  			{
							*(paramData+gotChars+1) = CPch;
							gotChars++;
							};
					};
			};
		if (( CPch == '|') && (gotChars == 0) )
			{
			gotReturns++;
			};
		};
	// for values with a trailing | this will be already set, but
	//    if we exited because we reached the end, reset length
	if (  (x > (CPhdlsize - 1)) && (!gotParam))  
		sizeOfParam = gotChars;
	*(paramSize) = sizeOfParam; 
} // getParamByNumber




static void getSlashParamByNumber(FHandle complexParameters, short ParamNum, unsigned int maxReturnSize, unsigned char  *paramData, unsigned int *paramSize)
{
// paramData will begin and [1] and end at [size], it's up to you to put *paramSize in [0] 
//      or if it is supposed to be a c-string you must set origin at [-1] instead of [0] and put /0 at [size] 
	long			CPhdlsize;
	unsigned char	*CPchptr;
	unsigned char	CPch;
	unsigned int		sizeOfParam;
	unsigned int		x;
	unsigned int 		gotChars;
	unsigned int		gotReturns;
	unsigned char		gotParam;
	
	gotChars = 0;
	gotReturns = 0;
	gotParam = false;
	sizeOfParam = 0;
	
	CPhdlsize = FMX_GetHandleSize(complexParameters);
	CPchptr = *complexParameters;

	for (x = 0; ( (x <= (CPhdlsize - 1)) && (!gotParam)  && (gotChars <= maxReturnSize)); x++)
		{
		CPch = *(CPchptr+x);
		if ( (gotReturns+1) == ParamNum)
			{
				if (  (CPch == '/') && (gotChars > 0 ) )
					{
						gotParam = true;
						sizeOfParam = gotChars;
						gotChars = 0;
					}
				  else
				  	{
				  		if ( (CPch != '/') )
				  			{
							*(paramData+gotChars+1) = CPch;
							gotChars++;
							};
					};
			};
		if (( CPch == '/') && (gotChars == 0) )
			{
			gotReturns++;
			};
		};
	// for values with a trailing | this will be already set, but
	//    if we exited because we reached the end, reset length
	if (  (x > (CPhdlsize - 1)) && (!gotParam))  
		sizeOfParam = gotChars;
	*(paramSize) = sizeOfParam; 
} // getSlashParamByNumber


// return all data after the ParamNum(th) in a pipe-delim'd string contained in a (filemaker) handle...
static void getAllAfterParamNumber(FHandle complexParameters, short ParamNum, unsigned int maxReturnSize, unsigned char  *paramData, unsigned int *paramSize)
{
// paramData will begin and [1] and end at [size], it's up to you to put *paramSize in [0] or /0 at [size+1] and set origin
//    at [size+1] instead of [0]
// used for file OPs: Append and Write and WriteLine

	long			CPhdlsize;
	unsigned char	*CPchptr;
	unsigned char	CPch;
	unsigned int		sizeOfParam;
	unsigned int		x;
	unsigned int 		gotChars;
	unsigned int		gotReturns;
	Boolean		gotParam;
	
	gotChars = 0;
	gotReturns = 0;
	gotParam = false;
	sizeOfParam = 1;
	
	CPhdlsize = FMX_GetHandleSize(complexParameters);
	CPchptr = *complexParameters;

	for (x = 0; ( x <= (maxReturnSize - 1)) && (x <= (CPhdlsize - 1)) && (!gotParam) && (sizeOfParam <= maxReturnSize) && (gotChars <= maxReturnSize); x++)
		{
		CPch = *(CPchptr+x);
		if ( (gotReturns+1) == ParamNum)
			{
				*(paramData+gotChars+1) = CPch;
				gotChars++;
			};
		if (( CPch == '|') && (gotChars == 0) )
			{
			gotReturns++;
			};
		};
	// for values with a trailing | this will be already set, but
	//    if we exited because we reached the end, reset length
	if (  (x > (CPhdlsize - 1)) && (!gotParam))  
		sizeOfParam = gotChars;
	*(paramSize) = sizeOfParam; 
} // getAllAfterParamNumber




// CrossPlatform Simple Error Dialog
static void DisplayErrorNumber(int messageid, int value, int debugStage) {
#if FM_CPU_X86
	char	caption[64];
	char	bodytplate[64];
	char	bodytext[64];

	LoadString((HINSTANCE)gFMExternCallPtr->instanceID, messageid, caption, sizeof(caption));
	LoadString((HINSTANCE)gFMExternCallPtr->instanceID, messageid + 1, bodytplate, sizeof(bodytplate));
	// value contains the Windows err encountered, debugStage contains the place in the source code the error occured.
	wsprintf(bodytext, bodytplate, value, debugStage);
	MessageBox(NULL, bodytext, caption, MB_OK | MB_TASKMODAL);
#else
	Str255	errstring;
	Str255  stagestring;
	Str255	emptystring;
	short fmOriginalResPath = CurResFile();
	
	// value contains the MacOS err encountered, debugStage contains the place in the source code the error occured.
	UseResFile(pb_resourceID);

	NumToString(value, errstring);
	NumToString(debugStage,stagestring);
	emptystring[0] = 0;
	ParamText(errstring, stagestring, emptystring, emptystring);
	CautionAlert((short)messageid, nil);
	
	UseResFile(fmOriginalResPath);
#endif
} // DisplayErrorNumber



static unsigned long lengthofCString ( unsigned char *sourceStr)
{
unsigned long scanForNullPos;

for (scanForNullPos = 0; ((*(sourceStr+scanForNullPos) != 0) && (scanForNullPos < 4294967000)); scanForNullPos++)
	{ // nop
	};
	
scanForNullPos++; // add one to include null....

return(scanForNullPos);
} // lengthofCString



// CrossPlatform Simple Message Dialog
static void DisplayMessageString(int messageid, unsigned char *msgString, int debugStage) {
#if FM_CPU_X86
	char	caption[64];
	char	bodytplate[64];
	char	bodytext[64];

	LoadString((HINSTANCE)gFMExternCallPtr->instanceID, messageid, caption, sizeof(caption));
	LoadString((HINSTANCE)gFMExternCallPtr->instanceID, messageid + 1, bodytplate, sizeof(bodytplate));
	// value contains the Windows err encountered, debugStage contains the place in the source code the error occured.
	wsprintf(bodytext, bodytplate, msgString, debugStage);
	MessageBox(NULL, bodytext, caption, MB_OK | MB_TASKMODAL);
#else
	Str255  stagestring;
	Str255	emptystring;
	long strParmSize;
	short fmOriginalResPath = CurResFile();
	
	// value contains the MacOS err encountered, debugStage contains the place in the source code the error occured.
	UseResFile(pb_resourceID);

	NumToString(debugStage,stagestring);
	emptystring[0] = 0;
	
	//strParmSize = lengthOfString(msgString);
	strParmSize = msgString[0];
	
	//BlockMoveData(msgString, (macMsgstring+1),strParmSize);
	//macMsgstring[0] = strParmSize;

	//ParamText(macMsgstring, stagestring, emptystring, emptystring);
	ParamText(msgString, stagestring, emptystring, emptystring);
	CautionAlert((short)messageid, nil);
	
	UseResFile(fmOriginalResPath);
#endif
} // DisplayMessageString



//  If the plugin is complied as a DEBUG version, then we're using DebugPlugin instead of the normal 
//   	"user" version for "ThisVersion".
//  While developing, or even testing the plugin at the user's site, this DEBUG version can be sent
//       different text flags as a parameter, and return data not normally accessible in the normal
// 		 version of the plugin.
//	 with "0" -
//			do the ThisVersion function (acts as if this is the "normal" version of the plugin).
//   with "1" -
//			this would return the preferences for the format function  (placeholder)

static void DebugPlugin(FHandle paramFromFMP,  FHandle functResult) {
	long			hdlsize;
	unsigned char	*chptr;
	unsigned char	ch;

hdlsize = FMX_GetHandleSize(paramFromFMP);
if (hdlsize > 0) {
	ch = 0;
	chptr = *paramFromFMP;
	ch = (*chptr);
	};


if ( hdlsize == 0) // means this plugin was called by a solution that was expecting the non-DEBUG version
	{
	FMX_SetHandleSize(functResult,24);
	if (FMX_MemoryError() == 0) 
		{ 
		BlockMoveData("DEBUG-INTERNAL USE ONLY!", *functResult, 24);
		};
	};


if ( ch == '0')  // ThisVersion
	{
	*chptr = 'P';  // change 0 to P to inform the function we want the platform with the version.
	PluginVersion (paramFromFMP, functResult);
	};


if ( ch == '1' ) // Debug stored CRYPT KEY
	{
	hdlsize = gCryptKeyLen;
	FMX_SetHandleSize(functResult, hdlsize);
	if (FMX_MemoryError() == 0) 
		{ 
		BlockMoveData(gCryptKey, *functResult, hdlsize);
		};
	};	
} // DebugPlugin



//  Returns the Current Version of the plugin, as hardcoded in the defines file "Dev.h"
// if the versTypeParam begins with "p" (for "platform"), the platform will be returned also
static void PluginVersion(FHandle versTypeParam,  FHandle result) {
	long			hdlsize;
	unsigned char	*chptr;
	unsigned char	ch;

/* check to see if we got something in the parameter */
	hdlsize = FMX_GetHandleSize(versTypeParam);
	if (hdlsize > 0) {
		ch = 0;
		chptr = *versTypeParam;
		ch = (*chptr);    // and set ch to the first letter 
		};

	// determine which type of version is desired
	if (    ( ch == 'p')     ||       ( ch== 'P')     ) 
		FMX_SetHandleSize(result,k_PlatformLength);
	     else
	     	FMX_SetHandleSize(result, kVersionLength);

	if (FMX_MemoryError() == 0) {    // if there was no mem error in allocation
#if FM_CPU_X86    // if this is a Windows version, use OS specific toolbox call
		// determine which type of version is desired
	if (    ( ch == 'p')     ||       ( ch== 'P')     )  
			lstrcpy((LPTSTR)*result, k_Platform);
		   else
		   	lstrcpy((LPTSTR)*result, kVersionString);
		   	
#else   // it's a mac version, so use the appropriate toolbox call
		// determine which type of version is desired
	if (    ( ch == 'p')     ||       ( ch== 'P')     )  
				BlockMoveData(k_Platform, *result, k_PlatformLength);
		   else
				BlockMoveData(kVersionString, *result, kVersionLength);
#endif
	}  
} // PluginVersion





// This is used by Do_AppPrefs to write the format string (in memory) to the plugins prefs on disk
static void writePrefs (void)
{
#if FM_CPU_X86
#else
	OSErr		macOSerr;
	short		vRefNum;
	OSType		folderType;
	Boolean		createFolder;
	short		fRefNum;
	FSSpec		prefsFileFSSpec;
	long		prefFileLineLen;
#endif

#if FM_CPU_X86 // use Windows way of getting/storing prefs
	// read registery prefs or sets defaults & creates reg entry
	
#else  // use Macintosh way of getting/storing prefs

	// obtain where the prefs file should be
	vRefNum = kOnSystemDisk;  // system volume of the user's machine
	folderType = kPreferencesFolderType; // look for the proper folder for preferences
	createFolder = kCreateFolder; // create folder if it doesn't already exist
	
	// get the disk/folder IDs
	macOSerr = FindFolder( vRefNum, folderType, createFolder, &(prefsFileFSSpec.vRefNum), &(prefsFileFSSpec.parID) ); 
	
	// read pref file or sets defaults & creates file
	
	// set the filename
	prefsFileFSSpec.name[0] = 6; // set length

	prefsFileFSSpec.name[1] = k_mRsrc1Creator;  
	prefsFileFSSpec.name[2] = k_mRsrc2Creator;  
	prefsFileFSSpec.name[3] = k_mRsrc3Creator; 
	prefsFileFSSpec.name[4] = k_mRsrc4Creator;  
	prefsFileFSSpec.name[5] = '.'; 
	prefsFileFSSpec.name[6] = (unsigned char)'';

	macOSerr = FSpOpenDF( &prefsFileFSSpec, fsCurPerm, &fRefNum ); // try to open the file, to see if it exists
		
	if (macOSerr == -43)
		{  // the file was not found, so create it using the prefs in memory, this should only happen if
		   //    the prefs file was deleted while FMP is running.

		macOSerr =FSpCreate( &prefsFileFSSpec, k_mRsrcCreator, 'TEXT', smSystemScript );
		macOSerr =FSpOpenDF( &prefsFileFSSpec, fsCurPerm, &fRefNum ); // try again to open the file
		};

	prefFileLineLen = pref_formatString[0]+1; // write out the whole string, including the leading length byte
	macOSerr =FSWrite( fRefNum, (long *) &prefFileLineLen, pref_formatString ); 
		
	FSClose(fRefNum);
#endif
}


#if FM_CPU_X86
BOOL APIENTRY prefProc (HWND mydlg, UINT dlgMsg, WPARAM wparm, LONG lparm)
{
	int x;
	BOOL hasFormatSymbols = FALSE;
	unsigned char tempPrefs[64];
	UINT tempPrefsLen;
	
	char regPath[256];
	char tempValue[256];
	PHKEY myRegKey;
	LPDWORD createKeyResult;
	DWORD ckResult;
	long regKeyResult;
	LPDWORD regKeyValueType;
	DWORD rkvType;
	LPBYTE regKeyValue;
	LPDWORD regKeyValueLength;
	DWORD rkvLength;

	lparm;
	ckResult = 0;   // in case we write changes to the Registry
	createKeyResult= &ckResult;
	rkvType = 0;
	regKeyValueType= &rkvType;
	rkvLength = 0;
	regKeyValueLength = &rkvLength;
	tempValue[0] = 0;
	regKeyValue = (unsigned char *)tempValue;
	lstrcpy( (LPTSTR)regPath, k_Reg_Path); 

	switch (dlgMsg)
	{
		case WM_INITDIALOG:
			SetFocus (GetDlgItem( mydlg, IDC_EDIT));  // set the focus to the ok button
			// and copy our settings to the edit text item - IDC_EDIT
			SetDlgItemText (mydlg, IDC_EDIT,pref_formatString);
			return FALSE;
			break;
		
		case WM_CLOSE:
			PostMessage(mydlg, WM_COMMAND, IDCANCEL, 0L);
			return FALSE;
			break;
		
		case WM_COMMAND:
		
			switch (wparm)
				{
				case IDCANCEL:
				EndDialog ( mydlg, FALSE );  // don't save changes
				break;
		
				case IDOK:
				// grab the format string from the edit text item 
				tempPrefsLen = GetDlgItemText( mydlg, IDC_EDIT, (LPSTR)tempPrefs, (k_maxSizeFormat+1));
				for (x = 0; x <= (int)tempPrefsLen;x++)
					{
					if (tempPrefs[x] == '#')
						hasFormatSymbols = TRUE;
					};
				
				// test item text to make sure it's a valid format for our function.  it must have something in it
				//    it must not be bigger than the max size for the format string, and it must have format symbols
				if ( (tempPrefsLen > 0) && (tempPrefsLen <= k_maxSizeFormat) && hasFormatSymbols)
					{ // copy the contents of the temp string into the format string
						lstrcpy((LPTSTR)pref_formatString, (const char *)tempPrefs);
						regKeyResult = RegCreateKeyEx (HKEY_CURRENT_USER, (const char *)regPath, 0, "REG_SZ\0", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS , NULL, (PHKEY)&myRegKey, createKeyResult);
						if ( regKeyResult != 0 )  // some sort of error
							{
							DisplayErrorNumber(kErrorMsg, regKeyResult, 111001);
							};

						regKeyResult = RegSetValueEx ( myRegKey, k_Reg_Key_Format, 0, REG_SZ, (CONST BYTE *)pref_formatString, (DWORD)(tempPrefsLen));
						if ( regKeyResult != 0 )
							{
							DisplayErrorNumber(kErrorMsg, regKeyResult, 111002);   
							};

							RegCloseKey (myRegKey);

							tempPrefsLen = lstrlen(pref_formatString);
							pref_formatString[tempPrefsLen+1] = 0;  // make sure the regKeyValue stored in the format string is null terminated
					
					EndDialog ( mydlg, TRUE );
					}
				    	else
				    	{ // reset the contents of item 3 to the format string
				      	//  and ignore the pressing of the ok button
				      	MessageBeep(0);
					SetDlgItemText (mydlg, IDC_EDIT, pref_formatString);
					SetFocus (GetDlgItem( mydlg, IDC_EDIT));
				    	};
				break;
				
				default:
					return FALSE;
			}; // end switch wparm
			break;
		
		default:
			return FALSE;
		}; // end switch dlgmsg

}
#endif


// ---------=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=--==--=-=-=-=-=-=-=-=--------

// ---------=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=--==--=-=-=-=-=-=-=-=--------

// ---------=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=--==--=-=-=-=-=-=-=-=--------



static void getVSN(FHandle result)
{
unsigned char tempGVN[32];
unsigned char tempGVNsize=0;

unsigned char	*resultPtr;

unsigned long theVSN=0;

long	hdlSize;


#if FM_CPU_X86
BOOL gviResult;

gviResult = GetVolumeInformation("C:\\\0", NULL, 0, &theVSN, (unsigned long *)NULL, (unsigned long *)NULL, NULL, 0);
if (gviResult == 0)
	{
		#if DEBUG_VERSION
		DisplayMessage(kErrorMsg, GetLastError());
		#endif
	};

convertUInt32toStr (0, theVSN, tempGVN, &tempGVNsize, 0);

if (gviResult)
	{
	FMX_SetHandleSize(result, tempGVNsize);
	if (FMX_MemoryError() == 0) 
		{
			resultPtr = *result;
			BlockMoveData (tempGVN, resultPtr, tempGVNsize);
		};
	}
	else
	{
	FMX_SetHandleSize(result, 1);
	if (FMX_MemoryError() == 0) 
		{
		resultPtr = *result;
		*(resultPtr+0) = '0';
		};
	}; // gviResult

#else

OSErr gviResult = 0;
unsigned char hasMAC;

ParamBlockRec	tempPBCInfo;
DateTimeRec	myDTRec;

FMX_SetHandleSize(result, 80);
if (FMX_MemoryError() == 0) 
	{
		FMX_LockHandle(result);
		resultPtr = *result;
		hasMAC = getBurnedInMAC(resultPtr, &hdlSize);
		FMX_UnlockHandle(result);
	};

if (hasMAC == 1)
	{
		FMX_SetHandleSize(result, hdlSize);
	}
	else
	{
		tempPBCInfo.volumeParam.ioCompletion = nil; // not async
		tempPBCInfo.volumeParam.ioVolIndex = 0;
		tempPBCInfo.volumeParam.ioVRefNum = 0;
		//tempPBCInfo.ioDirID = 1;
		//tempPBCInfo.ioFDirIndex = 1; // don't use ioNamePtr
		tempPBCInfo.volumeParam.ioNamePtr = nil;


		// Now lets do the real work....
		gviResult = PBGetVInfo (&tempPBCInfo, 0); // not async
		if (gviResult != 0)
			{
				#if DEBUG_VERSION
				DisplayErrorNumber(kErrorMsg, gviResult,999);
				#endif
				gviResult = 0;
			}
			else
			{
				gviResult = 1;
			};

		SecondsToDate(tempPBCInfo.volumeParam.ioVCrDate, &myDTRec);

		// concatenate ssmmhhddmm together... (yy or yyyy would overflow the long, so we can't include it....)
		theVSN = (unsigned long)(myDTRec.second + (myDTRec.minute * 100L) + (myDTRec.hour * 10000L) + (myDTRec.day * 1000000L) + (myDTRec.month * 100000000L));  // 100000000L
		
		// so prepend the year in hex pairs instead...
		convertUInt8toHex (tempGVN, (unsigned char)(((myDTRec.year)-(myDTRec.year % 100))/100)); // century
		convertUInt8toHex (tempGVN+2, (unsigned char)(myDTRec.year % 100)); // year

		convertUInt32toStr (0, theVSN, tempGVN+4, &tempGVNsize, 0);
		tempGVNsize = (unsigned char)(tempGVNsize + (unsigned char)4);
		
		if (gviResult)
			{
			FMX_SetHandleSize(result, tempGVNsize);
			if (FMX_MemoryError() == 0) 
				{
					resultPtr = *result;
					BlockMoveData (tempGVN, resultPtr, tempGVNsize);
				};
			}
			else
			{
			FMX_SetHandleSize(result, 1);
			if (FMX_MemoryError() == 0) 
				{
				resultPtr = *result;
				*(resultPtr+0) = '0';
				};
			}; // gviResult
			
	}; // hasMAC == 1
	
	
#endif
 } //  getVSN



static long convertStringToSInt32 (unsigned char *theCstring, unsigned long maxStrSize)
{
long	tempLong;

unsigned char x;
unsigned char xStart;
unsigned char tempCh;

tempLong = 0;

if (theCstring != nil)
	{
	xStart = 0;
	tempCh = 1;

	if (theCstring[0] == '-')
		{
			xStart = 1;
		};
		
	for (x = xStart; (x < maxStrSize) && (tempCh != 0); x++)
		{
		tempCh = *(theCstring+x);
		if ((tempCh >= '0') && (tempCh <= '9'))
			{
				tempLong *= 10;
				tempLong += (long)(tempCh-'0');
			};
		};
		
	// if the number was negative, lets reverse the (positive) sign...
	if ( theCstring[0] == '-' )
		{
		tempLong *= -1;
		};
	};

return(tempLong);
} //  convertStringToSInt32



static void convertUInt32toStr (unsigned char charPad, unsigned long theLong, unsigned char *theString, unsigned char *theStrLen, unsigned char withNullTerm)
{
unsigned long theWork; // 4294967296 of 4294967296    
unsigned long theTemp;
unsigned char tempLen; 

theWork = theLong;
theTemp =0;

if ( charPad == 0)
	{
		tempLen = 0;
		
		if (theWork > 999999999)
			{
				theTemp = (UInt32)(theWork / 1000000000);
				*(theString+tempLen) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 1000000000);
				theWork -= theTemp;
				
				tempLen++;
			};
		if (theWork > 99999999)
			{
				theTemp = (UInt32)(theWork / 100000000);
				*(theString+tempLen) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 100000000);
				theWork -= theTemp;
				
				tempLen++;
			}
			else
			{
				if (tempLen != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+tempLen) = (unsigned char)'0';
						tempLen++;
					};
			};
		if (theWork > 9999999)
			{
				theTemp = (UInt32)(theWork / 10000000);
				*(theString+tempLen) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 10000000);
				theWork -= theTemp;
				
				tempLen++;
			}
			else
			{
				if (tempLen != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+tempLen) = (unsigned char)'0';
						tempLen++;
					};
			};
		if (theWork > 999999)
			{
				theTemp = (UInt32)(theWork / 1000000);
				*(theString+tempLen) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 1000000);
				theWork -= theTemp;
				
				tempLen++;
			}
			else
			{
				if (tempLen != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+tempLen) = (unsigned char)'0';
						tempLen++;
					};
			};
		if (theWork > 99999)
			{
				theTemp = (UInt32)(theWork / 100000);
				*(theString+tempLen) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 100000);
				theWork -= theTemp;
				
				tempLen++;
			}
			else
			{
				if (tempLen != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+tempLen) = (unsigned char)'0';
						tempLen++;
					};
			};
		if (theWork > 9999)
			{
				theTemp = (UInt32)(theWork / 10000);
				*(theString+tempLen) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 10000);
				theWork -= theTemp;
				
				tempLen++;
			}
			else
			{
				if (tempLen != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+tempLen) = (unsigned char)'0';
						tempLen++;
					};
			};
		if (theWork > 999)
			{
				theTemp = (UInt32)(theWork / 1000);
				*(theString+tempLen) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 1000);
				theWork -= theTemp;
				
				tempLen++;
			}
			else
			{
				if (tempLen != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+tempLen) = (unsigned char)'0';
						tempLen++;
					};
			};
		if (theWork > 99)
			{
				theTemp = (UInt32)(theWork / 100);
				*(theString+tempLen) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 100);
				theWork -= theTemp;
				
				tempLen++;
			}
			else
			{
				if (tempLen != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+tempLen) = (unsigned char)'0';
						tempLen++;
					};
			};
		if (theWork > 9)
			{
				theTemp = (UInt32)(theWork / 10);
				*(theString+tempLen) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 10);
				theWork -= theTemp;
				
				tempLen++;
			}
			else
			{
				if (tempLen != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+tempLen) = (unsigned char)'0';
						tempLen++;
					};
			};
			
			*(theString+tempLen) = (unsigned char)('0' + theWork);
			tempLen++;
	}
	else
	{
		tempLen = 10;
		
		*(theString) = charPad;
		*(theString+1) = charPad;
		*(theString+2) = charPad;
		*(theString+3) = charPad;
		*(theString+4) = charPad;
		*(theString+5) = charPad;
		*(theString+6) = charPad;
		*(theString+7) = charPad;
		*(theString+8) = charPad;
		*(theString+9) = charPad;
		
		if (theWork > 999999999)
			{
				theTemp = (UInt32)(theWork / 1000000000);
				*(theString) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 1000000000);
				theWork -= theTemp;
			};	
		if (theWork > 99999999)
			{
				theTemp = (UInt32)(theWork / 100000000);
				*(theString+1) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 100000000);
				theWork -= theTemp;
			}
			else
			{
				if (theTemp != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+1) = (unsigned char)'0';
					};
			};
		if (theWork > 9999999)
			{
				theTemp = (UInt32)(theWork / 10000000);
				*(theString+2) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 10000000);
				theWork -= theTemp;
			}
			else
			{
				if (theTemp != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+2) = (unsigned char)'0';
					};
			};
		if (theWork > 999999)
			{
				theTemp = (UInt32)(theWork / 1000000);
				*(theString+3) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 1000000);
				theWork -= theTemp;
			}
			else
			{
				if (theTemp != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+3) = (unsigned char)'0';
					};
			};
		if (theWork > 99999)
			{
				theTemp = (UInt32)(theWork / 100000);
				*(theString+4) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 100000);
				theWork -= theTemp;
			}
			else
			{
				if (theTemp != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+4) = (unsigned char)'0';
					};
			};
		if (theWork > 9999)
			{
				theTemp = (UInt32)(theWork / 10000);
				*(theString+5) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 10000);
				theWork -= theTemp;
			}
			else
			{
				if (theTemp != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+5) = (unsigned char)'0';
					};
			};
		if (theWork > 999)
			{
				theTemp = (UInt32)(theWork / 1000);
				*(theString+6) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 1000);
				theWork -= theTemp;
			}
			else
			{
				if (theTemp != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+6) = (unsigned char)'0';
					};
			};
		if (theWork > 99)
			{
				theTemp = (UInt32)(theWork / 100);
				*(theString+7) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 100);
				theWork -= theTemp;
			}
			else
			{
				if (theTemp != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+7) = (unsigned char)'0';
					};
			};
		if (theWork > 9)
			{
				theTemp = (UInt32)(theWork / 10);
				*(theString+8) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 10);
				theWork -= theTemp;
			}
			else
			{
				if (theTemp != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+8) = (unsigned char)'0';
					};
			};
		*(theString+9) = (unsigned char)('0' + theWork);
	};

if (withNullTerm == (unsigned char)1)
	{
		*(theString+tempLen) = '\0';
		tempLen++; // include null terminator in size....
	};
	
*theStrLen = tempLen;
} // convertUInt32toStr



static void convertSInt32toStr (unsigned char charPad, long theLong, unsigned char *theString, unsigned char *theStrLen, unsigned char withNullTerm)
{
unsigned long theWork; // 2147483648 of 4294967296 
unsigned long theTemp;
unsigned char tempLen;
unsigned char isNeg;

if (theLong < 0)
	{
		theWork = (UInt32)(theLong * -1);
		isNeg = 1;
	}
	else
	{
		theWork = (UInt32)(1+theLong-1);
		isNeg = 0;
	};
theTemp =0;
	
if ( charPad == 0)
	{
		tempLen = 0;
		
		if (isNeg)
			{
				*(theString+tempLen) = '-';
				tempLen++;
			};
		
		if (theWork > 999999999)
			{
				theTemp = (UInt32)(theWork / 1000000000);
				*(theString+tempLen) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 1000000000);
				theWork -= theTemp;
				
				tempLen++;
			};
		if (theWork > 99999999)
			{
				theTemp = (UInt32)(theWork / 100000000);
				*(theString+tempLen) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 100000000);
				theWork -= theTemp;
				
				tempLen++;
			}
			else
			{
				if (((!isNeg) && (tempLen == 1)) || ((isNeg) && (tempLen == 2)))  // make sure to not count '-' as a preceeding digit...
					{ // there was a digit before us, we are just 0 here...
					*(theString+tempLen) = (unsigned char)'0';
						tempLen++;
					};
			};
		if (theWork > 9999999)
			{
				theTemp = (UInt32)(theWork / 10000000);
				*(theString+tempLen) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 10000000);
				theWork -= theTemp;
				
				tempLen++;
			}
			else
			{
				if (((!isNeg) && (tempLen >= 1)) || ((isNeg) && (tempLen >= 2)))  // make sure to not count '-' as a preceeding digit...
					{ // there was a digit before us, we are just 0 here...
					*(theString+tempLen) = (unsigned char)'0';
						tempLen++;
					};
			};
		if (theWork > 999999)
			{
				theTemp = (UInt32)(theWork / 1000000);
				*(theString+tempLen) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 1000000);
				theWork -= theTemp;
				
				tempLen++;
			}
			else
			{
				if (((!isNeg) && (tempLen >= 1)) || ((isNeg) && (tempLen >= 2)))  // make sure to not count '-' as a preceeding digit...
					{ // there was a digit before us, we are just 0 here...
					*(theString+tempLen) = (unsigned char)'0';
						tempLen++;
					};
			};
		if (theWork > 99999)
			{
				theTemp = (UInt32)(theWork / 100000);
				*(theString+tempLen) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 100000);
				theWork -= theTemp;
				
				tempLen++;
			}
			else
			{
				if (((!isNeg) && (tempLen >= 1)) || ((isNeg) && (tempLen >= 2)))  // make sure to not count '-' as a preceeding digit...
					{ // there was a digit before us, we are just 0 here...
					*(theString+tempLen) = (unsigned char)'0';
						tempLen++;
					};
			};
		if (theWork > 9999)
			{
				theTemp = (UInt32)(theWork / 10000);
				*(theString+tempLen) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 10000);
				theWork -= theTemp;
				
				tempLen++;
			}
			else
			{
				if (((!isNeg) && (tempLen >= 1)) || ((isNeg) && (tempLen >= 2)))  // make sure to not count '-' as a preceeding digit...
					{ // there was a digit before us, we are just 0 here...
					*(theString+tempLen) = (unsigned char)'0';
						tempLen++;
					};
			};
		if (theWork > 999)
			{
				theTemp = (UInt32)(theWork / 1000);
				*(theString+tempLen) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 1000);
				theWork -= theTemp;
				
				tempLen++;
			}
			else
			{
				if (((!isNeg) && (tempLen >= 1)) || ((isNeg) && (tempLen >= 2)))  // make sure to not count '-' as a preceeding digit...
					{ // there was a digit before us, we are just 0 here...
					*(theString+tempLen) = (unsigned char)'0';
						tempLen++;
					};
			};
		if (theWork > 99)
			{
				theTemp = (UInt32)(theWork / 100);
				*(theString+tempLen) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 100);
				theWork -= theTemp;
				
				tempLen++;
			}
			else
			{
				if (((!isNeg) && (tempLen >= 1)) || ((isNeg) && (tempLen >= 2)))  // make sure to not count '-' as a preceeding digit...
					{ // there was a digit before us, we are just 0 here...
					*(theString+tempLen) = (unsigned char)'0';
						tempLen++;
					};
			};
		if (theWork > 9)
			{
				theTemp = (UInt32)(theWork / 10);
				*(theString+tempLen) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 10);
				theWork -= theTemp;
				
				tempLen++;
			}
			else
			{
				if (((!isNeg) && (tempLen >= 1)) || ((isNeg) && (tempLen >= 2)))  // make sure to not count '-' as a preceeding digit...
					{ // there was a digit before us, we are just 0 here...
					*(theString+tempLen) = (unsigned char)'0';
						tempLen++;
					};
			};
			
			*(theString+tempLen) = (unsigned char)('0' + theWork);
			tempLen++;
	}
	else
	{
		tempLen = 11;
		if (isNeg)
			{
				*(theString) = '-';
			}
			else
			{
				*(theString) = charPad;
			};
			
		*(theString+1) = charPad;
		*(theString+2) = charPad;
		*(theString+3) = charPad;
		*(theString+4) = charPad;
		*(theString+5) = charPad;
		*(theString+6) = charPad;
		*(theString+7) = charPad;
		*(theString+8) = charPad;
		*(theString+9) = charPad;
		*(theString+10) = charPad;

		if (theWork > 999999999)
			{
				theTemp = (UInt32)(theWork / 1000000000);
				*(theString+1) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 1000000000);
				theWork -= theTemp;
			};	
		if (theWork > 99999999)
			{
				theTemp = (UInt32)(theWork / 100000000);
				*(theString+2) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 100000000);
				theWork -= theTemp;
			}	
			else
			{
				if (theTemp != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+2) = (unsigned char)'0';
					};
			};
		if (theWork > 9999999)
			{
				theTemp = (UInt32)(theWork / 10000000);
				*(theString+3) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 10000000);
				theWork -= theTemp;
			}	
			else
			{
				if (theTemp != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+3) = (unsigned char)'0';
					};
			};
		if (theWork > 999999)
			{
				theTemp = (UInt32)(theWork / 1000000);
				*(theString+4) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 1000000);
				theWork -= theTemp;
			}	
			else
			{
				if (theTemp != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+4) = (unsigned char)'0';
					};
			};
		if (theWork > 99999)
			{
				theTemp = (UInt32)(theWork / 100000);
				*(theString+5) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 100000);
				theWork -= theTemp;
			}	
			else
			{
				if (theTemp != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+5) = (unsigned char)'0';
					};
			};
		if (theWork > 9999)
			{
				theTemp = (UInt32)(theWork / 10000);
				*(theString+6) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 10000);
				theWork -= theTemp;
			}	
			else
			{
				if (theTemp != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+6) = (unsigned char)'0';
					};
			};
		if (theWork > 999)
			{
				theTemp = (UInt32)(theWork / 1000);
				*(theString+7) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 1000);
				theWork -= theTemp;
			}	
			else
			{
				if (theTemp != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+7) = (unsigned char)'0';
					};
			};
		if (theWork > 99)
			{
				theTemp = (UInt32)(theWork / 100);
				*(theString+8) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 100);
				theWork -= theTemp;
			}	
			else
			{
				if (theTemp != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+8) = (unsigned char)'0';
					};
			};
		if (theWork > 9)
			{
				theTemp = (UInt32)(theWork / 10);
				*(theString+9) = (unsigned char)('0' + theTemp);
				theTemp = (UInt32)(theTemp * 10);
				theWork -= theTemp;
			}	
			else
			{
				if (theTemp != 0)
					{ // there was a digit before us, we are just 0 here...
					*(theString+9) = (unsigned char)'0';
					};
			};
		*(theString+10) = (unsigned char)('0' + theWork);
	};

if (withNullTerm == (unsigned char)1)
	{
		*(theString+tempLen) = '\0';
		tempLen++; // include null terminator in size....
	};
	
*theStrLen = tempLen;
} // convertSInt32toStr



static unsigned char getBurnedInMAC(unsigned char *stringDest, long *newStringLen)
{
unsigned char	gotMAC=0;

#if FM_CPU_X86
#else
	int		err;
	unsigned long		cputype;
	unsigned char		enetaddr[6];
	
	unsigned long	i;
	unsigned char	*val;
    RegEntryIter            cookie;
    RegEntryID              theFoundEntry;
    char          	enetAddrStr[32] = "local-mac-address\0";
    RegCStrEntryNamePtr     enetAddrCStr = enetAddrStr;
//    RegEntryIterationOp     iterOp;
    RegPropertyValueSize	theSize;

	//fprintf(stdout, "First, get the burned-in ethernet address directly from ROM or NameRegistry\n");
	cputype = getCPUEthernetType();
	switch (cputype)
	{
		case kPDMMachine:
				for (i = 0; i < 6; i++)
				{
					val = (UInt8 *)(kPDMEnetROMBase + i * 0x10);
					enetaddr[i] = ByteSwapValue(*val);
				}; // for
				gotMAC = 1;
			break;
		
		case kPCIMachine:
				#if FM_CPU_PPC
			    err = RegistryEntryIDInit( &theFoundEntry );
				if (err == noErr)
				{
				    err = RegistryEntryIterateCreate( &cookie );
					if (err == noErr)
					{
					    //iterOp = kRegIterDescendants;
					    err = RegistryEntrySearch( &cookie, (RegEntryIterationOp)kRegIterDescendants, &theFoundEntry, &gotMAC, enetAddrCStr, nil, 0);
					    if (err == noErr)
					    {
						    theSize = sizeof(enetaddr);;
						    err = RegistryPropertyGet(&theFoundEntry, enetAddrCStr, &enetaddr, &theSize );
						    if (err == noErr)
						    	{
									gotMAC = 1;				
						    	}
						    	else
						    	{
									gotMAC = 0;				
						    	}; // err == noErr
						}
						else
						{
							gotMAC = 0;				
						}; // err == noErr
						
					}; // err == noErr
				    RegistryEntryIterateDispose( &cookie );
				
				}; // err == noErr
			#else
			gotMAC = 0;	
			#endif
			break;
				
		default:
			gotMAC = 0;
			break;
	}; // switch
	
if (gotMAC == 1)
	{
		// turn enetaddr into a string starting at stringDest and update length in newStringLen
		convertUInt8toHex (stringDest, enetaddr[0]);
		convertUInt8toHex (stringDest+2, enetaddr[1]);
		convertUInt8toHex (stringDest+4, enetaddr[2]);
		convertUInt8toHex (stringDest+6, enetaddr[3]);
		convertUInt8toHex (stringDest+8, enetaddr[4]);
		convertUInt8toHex (stringDest+10, enetaddr[5]);
		
		*newStringLen = 12;
	}
	else
	{
		*newStringLen = 0;
	};
	
#endif

return(gotMAC);
} // getBurnedInMAC



static unsigned long getCPUEthernetType(void)
{
#if FM_CPU_X86
#else
	long		response;
//	OSStatus	err;
	OSErr	err;
	unsigned long	result = kUnsupported;
	
	err = Gestalt(gestaltMachineType, &response);
	switch (response)
	{
		case gestaltPowerMac8100_120:
		case gestaltAWS9150_80:
		case gestaltPowerMac8100_110:
		case gestaltPowerMac7100_80:
		case gestaltPowerMac8100_100:
		case gestaltAWS9150_120:
		case gestaltPowerMac8100_80:
		case gestaltPowerMac6100_60:
		case gestaltPowerMac6100_66:
		case gestaltPowerMac7100_66:
			result = kPDMMachine;
			break;
		
		case gestaltPowerMac9500:
		case gestaltPowerMac7500:
		case gestaltPowerMac8500:
		case gestaltPowerBook3400:
		case gestaltPowerBookG3:
		case gestaltPowerMac7200:
		case gestaltPowerMac7300:
		case gestaltPowerBookG3Series:
		case gestaltPowerBookG3SeriesFSTN:
		case gestaltPowerMacG3:
		case gestaltiMac:
			result = kPCIMachine;
			break;
			
		case gestaltPowerMac5200:
		case gestaltPowerMac6200:
			result = kCommSlotMachine;
			break;
			
		case gestaltPowerMac6400:
		case gestaltPowerMac5400:
		case gestaltPowerMac5500:
		case gestaltPowerMac6500:
		case gestaltPowerMac4400_160:
		case gestaltPowerMac4400:
			result = kPCIComm2Machine;
			break;
			
		case kUnsupported:
			err = Gestalt(gestaltNameRegistryVersion, (long*) &response);
				if (err == noErr)
					{
					result = kPCIMachine;
					}
					else
					{
					// result = kUnsupported;   // already set
					};
			break;
	}; // switch
#endif

return (result);
} // getCPUEthernetType



static unsigned char	ByteSwapValue(unsigned char val)
{
	unsigned char	result = 0;
	
	if (val & 0x01)
		result |= 0x80;
		
	if (val & 0x02)
		result |= 0x40;
		
	if (val & 0x04)
		result |= 0x20;
		
	if (val & 0x08)
		result |= 0x10;
		
	if (val & 0x10)
		result |= 0x08;
		
	if (val & 0x20)
		result |= 0x04;
		
	if (val & 0x40)
		result |= 0x02;
		
	if (val & 0x80)
		result |= 0x01;
		
	return (result);
} // ByteSwapValue




// turns a UInt8 into a Hex Pair String,  DOES NOT RETURN NULL TERMINATED!!!
//
static void convertUInt8toHex (unsigned char *twoCharStr, unsigned char theByte)
{
unsigned char		tempByte;
unsigned char		workByte;
unsigned char	firstChar;
unsigned char	secondChar;

tempByte = theByte;

if (tempByte>15)
	{
		workByte = (unsigned char)(tempByte/16);
		workByte *= 16;
		workByte = (unsigned char)(workByte/16);
		if (workByte> 9)
			workByte += 7;  //  puts 10 = "A" instead of ":"
		firstChar = (unsigned char) ( '0' + workByte );
		if (workByte> 9)
			workByte -= 7;  //  back out character "A" hack, for next digit....
		tempByte -= workByte*16;
	}
	else
		firstChar = '0';

if (tempByte<16)
	{
		if (tempByte> 9)
			tempByte += 7;  //  puts 10 = "A" instead of ":"
		secondChar = (unsigned char) ( '0' + tempByte );
	}
	else
		secondChar = '0';
		
twoCharStr[0] = firstChar;
twoCharStr[1] = secondChar;

} // convertUInt8toHex



static void convertHextoUInt8 (unsigned char *twoCharStr, unsigned char *theByte)
{
unsigned char		tempByte;
unsigned char		tempChar;

unsigned char	loopChar;

*theByte = 0;

tempByte = 0;
for (loopChar = 0; loopChar < 2; loopChar++)
	{
		tempChar = twoCharStr[loopChar];
		// 0 = 48
		if ((tempChar >= '0') && (tempChar <= '9'))
			{
				tempByte = (unsigned char)((unsigned char)tempByte * (unsigned char)16);
				tempByte = (unsigned char)((unsigned char)tempByte + (unsigned char)(tempChar-48));
			};
		// A = 65
		if ((tempChar >= 'A') && (tempChar <= 'F'))
			{
				tempByte = (unsigned char)((unsigned char)tempByte * (unsigned char)16);
				tempByte = (unsigned char)((unsigned char)tempByte + (unsigned char)((tempChar-65) + 10));
			};
		
		// a = 97
		if ((tempChar >= 'a') && (tempChar <= 'f'))
			{
				tempByte = (unsigned char)((unsigned char)tempByte * (unsigned char)16);
				tempByte = (unsigned char)((unsigned char)tempByte + (unsigned char)((tempChar-97) + 10));
			};
	}; // loopChar

*theByte = tempByte;
} // convertHextoUInt8




static long zeroCleanMemory (unsigned char *ptrToClean, long sizeOfPtr)
{
unsigned long *ptrTypeCastedLong;
long clearLoopCounter;

long numOfLongs;

if (ptrToClean != nil)
	{
		ptrTypeCastedLong = (unsigned long *)ptrToClean; // long pointer assigned to the same memory as ptrToClean
		numOfLongs = (sizeOfPtr >> 2);   // fast way to int-divide by 4

		// clear the memory four bytes at a time so that clearing large portions of memory will be faster
		for (clearLoopCounter = 0; clearLoopCounter < numOfLongs; clearLoopCounter++)
			{
				*(ptrTypeCastedLong+clearLoopCounter) = 0L;
			};
		
		// since we cleared memory in 4-byte chunks, there may be a tail-end remainder, lets clear that out
		//	1 byte at a time (should be less than 3 bytes worst-case anyway)...  // NOTE: Codewarrior will pad structures to 4 bytes on PPC, so this is not really necessary in most cases, but the exceptions...
		for (clearLoopCounter = (numOfLongs * 4); clearLoopCounter < sizeOfPtr; clearLoopCounter++)
			{
				*(ptrToClean+clearLoopCounter) = 0;
			};
					
		return(0);
	}
	else
	{
		return(-1);
	};
} // zeroCleanMemory




static void storeCryptKey(FHandle param, FHandle result)
{
long phdlSize;
long rhdlSize;

char boolStoreResult;
int mFerr;

unsigned char *ptrInsideParam;
unsigned long tempLen;

unsigned char *ptrInsideResult;

int	chunkSize;
unsigned long loopChunks;


boolStoreResult = 0;
mFerr = 0;

phdlSize = FMX_GetHandleSize(param);

if (phdlSize > kCryptKeyLMaxSize)
	{
		phdlSize = kCryptKeyLMaxSize;
	};
	
// is the key long enough even to be accepted....
if (phdlSize >= kCryptKeyLMinSize)
	{
	
	//enlarge key so that it doesn't crash RC6...
	if (phdlSize < kCryptKeyHexMax)
		{
			// Also is "security through obscurity" by padding key with redundant, highbit chars
			//		if the cracker does not have this source, it makes her/his job more difficult against
			//		data encoded with "less secure" keys of length kCryptKeyLMinSize to kCryptKeyHexMax
			// Vary the particulars if you want this to be effective in your own version of the plug-in

			chunkSize = (int)kCryptKeyHexMax-phdlSize;  // how many chars do we need to add...

			FMX_SetHandleSize (param, phdlSize+chunkSize);
			mFerr = FMX_MemoryError();		
			if ( mFerr == 0)
					{
						FMX_LockHandle(param);					
						ptrInsideParam = *param;

						for (loopChunks = 0; loopChunks < chunkSize; loopChunks++)
							{
								*(ptrInsideParam+phdlSize+loopChunks) = (unsigned char)(255-((kCryptKeyLMaxSize-phdlSize)+(kCryptKeyHexMax-loopChunks)));
							};

						FMX_UnlockHandle(param);
						
						phdlSize = phdlSize + chunkSize;
					};
				};
					
		FMX_LockHandle(param);
		ptrInsideParam = *param;
		
		if ( (phdlSize >= kCryptKeyHexMin) && (phdlSize <= kCryptKeyHexMax))
			{
		 		crypto_StrToHex(ptrInsideParam, (unsigned long)phdlSize, gCryptKey, &tempLen);
		 		gCryptKeyLen = (unsigned char)tempLen;
		 		boolStoreResult = 0; // key is marginal
			}
			else
			{
				BlockMoveData(ptrInsideParam, gCryptKey, phdlSize);
				gCryptKeyLen = (unsigned char)phdlSize;
				boolStoreResult = 1; // key is strong
			};
			
		FMX_UnlockHandle(param);
		
		// Prepare our RC6 key...
		#if RC6_unopd
			rc6_key(rc6Key, gCryptKey, gCryptKeyLen);
		#else
			rc6_key(rc6Key, (unsigned long *)gCryptKey, gCryptKeyLen);					
		#endif


	}
	else
	{
		zeroCleanMemory(gCryptKey, kCryptKeyPSize);
		gCryptKeyLen = 0;
		
		boolStoreResult = -1;
		mFerr = -120;
	};

checkErrResult (boolStoreResult, mFerr, result);

} // storeCryptKey




static void encrypt_RC4(FHandle param, FHandle result)
{
long phdlSize;
long rhdlSize;

unsigned long tempSize;

char boolStoreResult;
int mFerr;

unsigned char *ptrInsideParam;
unsigned char *ptrInsideResult;

long blockHSizeChunks;
int	chunkSize;
unsigned long loopChunks;

rc4_t rc4Key;


boolStoreResult = 0;
mFerr = 0;

phdlSize = FMX_GetHandleSize(param);
if ((phdlSize != 0) && (gCryptKeyLen != 0))
	{
	if ((phdlSize < kDecryptedBufferMinSize) || (phdlSize > kDecryptedBufferLSize))
		{
			// The param is either too small, or two big, echo it back out to FMP (no loss of data)...
			FMX_LockHandle(param);
			ptrInsideParam = *param;
			
			FMX_SetHandleSize (result, phdlSize);
			mFerr = FMX_MemoryError();
			if ( mFerr == 0)
				{	// if no mem err, xfer param over to result...
					FMX_LockHandle(result);
					ptrInsideResult = *result;
					
					BlockMoveData (ptrInsideParam, ptrInsideResult, phdlSize);
					boolStoreResult = 0;
					mFerr = 0;
					
					FMX_UnlockHandle(result);
				}
				else
				{
					// not even enough mem for moving param back over to result...
					boolStoreResult = -1;
					
					#if FM_CPU_X86
						DisplayMessageString(kErrorMsg, "Warning out of memory, please give more to FMP.\0", 23401);
					#else
						DisplayMessageString(kErrorMsg, "\pWarning out of memory, please give more to FMP.", 23401);
					#endif
						
					#if DEBUG_VERSION
							DisplayErrorNumber(kErrorMsg, mFerr, 23401);
					#endif
					
					mFerr = -108;
				};
			
			FMX_UnlockHandle(param);
		}
		else
		{
			// The param is within the accepted size, encrypt it using the current key via the RC4 scheme...
			
			rhdlSize = phdlSize * 2; // encrypted param is twice as large as plaintext after hex encode...
			FMX_SetHandleSize (result, rhdlSize);
			mFerr = FMX_MemoryError();
			if ( mFerr == 0)
				{	// if no mem err, do the encryption...
					FMX_LockHandle(param);
					FMX_LockHandle(result);
					ptrInsideParam = *param;
					ptrInsideResult = *result;
					
					// ROTate/Obscure data, using the size of the key as the amount to rotate by...
					crypto_ROT(gCryptKeyLen, kROTencode, (unsigned long)phdlSize, ptrInsideParam);
					
					
					// Prepare our RC4 key...
					rc4_key(&rc4Key, gCryptKey, gCryptKeyLen);

					// Loop through data and pass it in chunks to scheme...
					blockHSizeChunks = (phdlSize >> kRC4ChunkSizeBits );
					for (loopChunks = 0; loopChunks < blockHSizeChunks; loopChunks++)
						{
							// Do the scheme
							rc4_crypt(&rc4Key, (ptrInsideParam+(loopChunks << kRC4ChunkSizeBits)), kRC4ChunkSize);
						};
					chunkSize = (int)(phdlSize - (blockHSizeChunks << kRC4ChunkSizeBits));
					if ( chunkSize > 0 )
						{
							rc4_crypt(&rc4Key, (ptrInsideParam+(loopChunks << kRC4ChunkSizeBits)), chunkSize);
						};

					ptrInsideParam = *param;
					ptrInsideResult = *result;
					
					// Do the hex encoding... // we already assumed it will be halfsize, so pass in tempSize as a dummy
					tempSize = (unsigned long)phdlSize;
					crypto_StrToHex(ptrInsideParam, tempSize, ptrInsideResult, &tempSize);

					FMX_UnlockHandle(param);
					FMX_UnlockHandle(result);
					
					// The paranoid can uncomment this block for extra security   --  (not used for RC4)
					// FMX_LockHandle(gCryptBuffer);
					// zeroCleanMemory(*gCryptBuffer, gCryptBufferSize);
					// FMX_UnlockHandle(gCryptBuffer);
					
					boolStoreResult = 0;
					mFerr = 0;
				}
				else
				{
					// not even enough mem for moving param back over to result...
					boolStoreResult = -1;
					
					#if FM_CPU_X86
						DisplayMessageString(kErrorMsg, "Warning out of memory, please give more to FMP.\0", 23402);
					#else
						DisplayMessageString(kErrorMsg, "\pWarning out of memory, please give more to FMP.", 23402);
					#endif
						
					#if DEBUG_VERSION
							DisplayErrorNumber(kErrorMsg, mFerr, 23402);
					#endif
					
					mFerr = -108;
				}; // mFerr == 0
			
		}; // phdlSize < kDecryptedBufferMinSize  ||  phdlSize > kDecryptedBufferLSize
	}
	else
	{
		// the param or key is 0/Nothing

			// The param is either too small, or two big, echo it back out to FMP (no loss of data)...
			FMX_LockHandle(param);
			ptrInsideParam = *param;
			
			FMX_SetHandleSize (result, phdlSize);
			mFerr = FMX_MemoryError();
			if ( mFerr == 0)
				{	// if no mem err, xfer param over to result...
					FMX_LockHandle(result);
					ptrInsideResult = *result;
					
					BlockMoveData (ptrInsideParam, ptrInsideResult, phdlSize);
					boolStoreResult = 0;
					mFerr = 0;
					
					FMX_UnlockHandle(result);
				}
				else
				{
					// not even enough mem for moving param back over to result...
					boolStoreResult = -1;
					
					#if FM_CPU_X86
						DisplayMessageString(kErrorMsg, "Warning out of memory, please give more to FMP.\0", 23499);
					#else
						DisplayMessageString(kErrorMsg, "\pWarning out of memory, please give more to FMP.", 23499);
					#endif
						
					#if DEBUG_VERSION
							DisplayErrorNumber(kErrorMsg, mFerr, 23499);
					#endif
					
					mFerr = -108;
				};
			
			FMX_UnlockHandle(param);

	}; // phdlSize != 0   &&  gCryptKeyLen != 0

checkErrResultIgnore (boolStoreResult, mFerr, result);
} // encrypt_RC4



static void decrypt_RC4(FHandle param, FHandle result)
{
long phdlSize;
long rhdlSize;

unsigned long tempSize;

char boolStoreResult;
int mFerr;

unsigned char *ptrInsideParam;
unsigned char *ptrInsideResult;

long blockHSizeChunks;
int	chunkSize;
unsigned long loopChunks;

rc4_t rc4Key;


boolStoreResult = 0;
mFerr = 0;
tempSize = 0;

phdlSize = FMX_GetHandleSize(param);
if ((phdlSize != 0) && (gCryptKeyLen != 0))
	{
	if ((phdlSize < kDecryptedBufferMinSize) || (phdlSize > kEncryptedBufferLSize))
		{
			// The param is either too small, or two big, echo it back out to FMP (no loss of data)...
			FMX_LockHandle(param);
			ptrInsideParam = *param;
			
			FMX_SetHandleSize (result, phdlSize);
			mFerr = FMX_MemoryError();
			if ( mFerr == 0)
				{	// if no mem err, xfer param over to result...
					FMX_LockHandle(result);
					ptrInsideResult = *result;
					
					BlockMoveData (ptrInsideParam, ptrInsideResult, phdlSize);
					boolStoreResult = 0;
					mFerr = 0;
					
					FMX_UnlockHandle(result);
				}
				else
				{
					// not even enough mem for moving param back over to result...
					boolStoreResult = -1;
					
					#if FM_CPU_X86
						DisplayMessageString(kErrorMsg, "Warning out of memory, please give more to FMP.\0", 23501);
					#else
						DisplayMessageString(kErrorMsg, "\pWarning out of memory, please give more to FMP.", 23501);
					#endif
						
					#if DEBUG_VERSION
							DisplayErrorNumber(kErrorMsg, mFerr, 23501);
					#endif
					
					mFerr = -108;
				};
			
			FMX_UnlockHandle(param);
		}
		else
		{
			// The param is within the accepted size, decrypt it using the current key via the RC4 scheme...
			
			rhdlSize = (phdlSize >> 1); // decrypted param is twice as small as plaintext after hex encode...
			FMX_SetHandleSize (result, rhdlSize);
			mFerr = FMX_MemoryError();
			if ( mFerr == 0)
				{	// if no mem err, do the decryption...
					FMX_LockHandle(param);
					FMX_LockHandle(result);
					ptrInsideParam = *param;
					ptrInsideResult = *result;
					
					// unencode hex into plaintext...
					crypto_HexToStr(ptrInsideParam, (unsigned long)phdlSize, ptrInsideResult, &tempSize);
		
					// Prepare our RC4 key...
					rc4_key(&rc4Key, gCryptKey, gCryptKeyLen);

					// Loop through data and pass it in chunks to scheme...
					blockHSizeChunks = (rhdlSize >> kRC4ChunkSizeBits );
					for (loopChunks = 0; loopChunks < blockHSizeChunks; loopChunks++)
						{
							// Do the scheme
							 rc4_crypt(&rc4Key, (ptrInsideResult+(loopChunks << kRC4ChunkSizeBits)), kRC4ChunkSize);
						};
					chunkSize = (int)(rhdlSize - (blockHSizeChunks << kRC4ChunkSizeBits));
					if ( chunkSize > 0 )
						{
							rc4_crypt(&rc4Key, (ptrInsideResult+(loopChunks << kRC4ChunkSizeBits)), chunkSize);
						};

					// ROTate/Obscure data, using the size of the key as the amount to rotate by...
					crypto_ROT(gCryptKeyLen, kROTdecode, (unsigned long)rhdlSize, ptrInsideResult);

					FMX_UnlockHandle(param);
					FMX_UnlockHandle(result);
					
					// The paranoid can uncomment this block for extra security   --  (not used for RC4)
					// FMX_LockHandle(gCryptBuffer);
					// zeroCleanMemory(*gCryptBuffer, gCryptBufferSize);
					// FMX_UnlockHandle(gCryptBuffer);
					
					boolStoreResult = 0;
					mFerr = 0;
				}
				else
				{
					// not even enough mem for moving param back over to result...
					boolStoreResult = -1;
					
					#if FM_CPU_X86
						DisplayMessageString(kErrorMsg, "Warning out of memory, please give more to FMP.\0", 23502);
					#else
						DisplayMessageString(kErrorMsg, "\pWarning out of memory, please give more to FMP.", 23502);
					#endif
						
					#if DEBUG_VERSION
							DisplayErrorNumber(kErrorMsg, mFerr, 23502);
					#endif
					
					mFerr = -108;
				}; // mFerr == 0
			
		}; // phdlSize < kDecryptedBufferMinSize  ||  phdlSize > kDecryptedBufferLSize
	}
	else
	{
			// The param is either too small, or two big, echo it back out to FMP (no loss of data)...
			FMX_LockHandle(param);
			ptrInsideParam = *param;
			
			FMX_SetHandleSize (result, phdlSize);
			mFerr = FMX_MemoryError();
			if ( mFerr == 0)
				{	// if no mem err, xfer param over to result...
					FMX_LockHandle(result);
					ptrInsideResult = *result;
					
					BlockMoveData (ptrInsideParam, ptrInsideResult, phdlSize);
					boolStoreResult = 0;
					mFerr = 0;
					
					FMX_UnlockHandle(result);
				}
				else
				{
					// not even enough mem for moving param back over to result...
					boolStoreResult = -1;
					
					#if FM_CPU_X86
						DisplayMessageString(kErrorMsg, "Warning out of memory, please give more to FMP.\0", 23599);
					#else
						DisplayMessageString(kErrorMsg, "\pWarning out of memory, please give more to FMP.", 23599);
					#endif
						
					#if DEBUG_VERSION
							DisplayErrorNumber(kErrorMsg, mFerr, 23599);
					#endif
					
					mFerr = -108;
				};
			
			FMX_UnlockHandle(param);

	}; // phdlSize != 0   &&  gCryptKeyLen != 0

checkErrResultIgnore (boolStoreResult, mFerr, result);
} // decrypt_RC4





static void encrypt_RC6(FHandle param, FHandle result)
{
long phdlSize;
long rhdlSize;

unsigned long tempSize;

char boolStoreResult;
int mFerr;

unsigned char *ptrInsideParam;
unsigned char *ptrInsideResult;

long blockHSizeChunks;
int	chunkSize;
unsigned long loopChunks;

// rc6_t rc6Key;


boolStoreResult = 0;
mFerr = 0;

phdlSize = FMX_GetHandleSize(param);
if ((phdlSize != 0) && (gCryptKeyLen != 0))
	{
	if ((phdlSize < kDecryptedBufferMinSize) || (phdlSize > kDecryptedBufferLSize))
		{
			// The param is either too small, or two big, echo it back out to FMP (no loss of data)...
			FMX_LockHandle(param);
			ptrInsideParam = *param;
			
			FMX_SetHandleSize (result, phdlSize);
			mFerr = FMX_MemoryError();
			if ( mFerr == 0)
				{	// if no mem err, xfer param over to result...
					FMX_LockHandle(result);
					ptrInsideResult = *result;
					
					BlockMoveData (ptrInsideParam, ptrInsideResult, phdlSize);
					boolStoreResult = 0;
					mFerr = 0;
					
					FMX_UnlockHandle(result);
				}
				else
				{
					// not even enough mem for moving param back over to result...
					boolStoreResult = -1;
					
					#if FM_CPU_X86
						DisplayMessageString(kErrorMsg, "Warning out of memory, please give more to FMP.\0", 23603);
					#else
						DisplayMessageString(kErrorMsg, "\pWarning out of memory, please give more to FMP.", 23603);
					#endif
						
					#if DEBUG_VERSION
							DisplayErrorNumber(kErrorMsg, mFerr, 23603);
					#endif
					
					mFerr = -108;
				};
			
			FMX_UnlockHandle(param);
		}
		else
		{
			// The param is within the accepted size, encrypt it using the current key via the RC6 scheme...
			
			// enlarge data so that it lies completely on kRC6ChunkSizeBits boundries...
			blockHSizeChunks = (phdlSize >> kRC6ChunkSizeBits );
			chunkSize = (int)(phdlSize - (blockHSizeChunks << kRC6ChunkSizeBits));
			if (chunkSize != 0)
				{
				FMX_SetHandleSize (param, phdlSize+chunkSize);
				mFerr = FMX_MemoryError();		
				if ( mFerr == 0)
					{
						FMX_LockHandle(param);					
						ptrInsideParam = *param;

						chunkSize = (kRC6ChunkSize-chunkSize);

						for (tempSize = 0; tempSize < chunkSize; tempSize++)
							{
								*(ptrInsideParam+phdlSize+tempSize) = ' ';
							};

						FMX_UnlockHandle(param);
						
						phdlSize = phdlSize + chunkSize;
						
						rhdlSize = phdlSize * 2; // encrypted param is twice as large as plaintext after hex encode...
						FMX_SetHandleSize (result, rhdlSize);
						mFerr = FMX_MemoryError();
					};
				}
				else
				{
					rhdlSize = phdlSize * 2; // encrypted param is twice as large as plaintext after hex encode...
					FMX_SetHandleSize (result, rhdlSize);
					mFerr = FMX_MemoryError();
				};			

			if ( mFerr == 0)
				{	// if no mem err, do the encryption...
					FMX_LockHandle(param);
					FMX_LockHandle(result);
					ptrInsideParam = *param;
					ptrInsideResult = *result;
					
					// ROTate/Obscure data, using the size of the key as the amount to rotate by...
					crypto_ROT(gCryptKeyLen, kROTencode, (unsigned long)phdlSize, ptrInsideParam);
										
					// Prepare our RC6 key...
					#if RC6_unopd
//						rc6_key(rc6Key, gCryptKey, gCryptKeyLen);
					#else
//						rc6_key(rc6Key, (unsigned long *)gCryptKey, gCryptKeyLen);					
					#endif

					ptrInsideParam = *param;
					ptrInsideResult = *gCryptBuffer;

					// Loop through data and pass it in chunks to scheme...
					blockHSizeChunks = (phdlSize >> kRC6ChunkSizeBits );
					for (loopChunks = 0; loopChunks < blockHSizeChunks; loopChunks++)
						{
							// Do the scheme
							rc6_encrypt(rc6Key, (unsigned long *)(ptrInsideParam+(loopChunks << kRC6ChunkSizeBits)), (unsigned long *)(ptrInsideResult+(loopChunks << kRC6ChunkSizeBits)));
						};
						
					ptrInsideParam = *gCryptBuffer;
					ptrInsideResult = *result;
					
					// Do the hex encoding... // we already assumed it will be halfsize, so pass in tempSize as a dummy
					tempSize = (unsigned long)phdlSize;
					crypto_StrToHex(ptrInsideParam, tempSize, ptrInsideResult, &tempSize);

					FMX_UnlockHandle(param);
					FMX_UnlockHandle(result);
					
					// The paranoid can uncomment this block for extra security   --  (not used for RC4)
					// FMX_LockHandle(gCryptBuffer);
					// zeroCleanMemory(*gCryptBuffer, gCryptBufferSize);
					// FMX_UnlockHandle(gCryptBuffer);
					
					boolStoreResult = 0;
					mFerr = 0;
				}
				else
				{
					// not even enough mem for moving param back over to result...
					boolStoreResult = -1;
					
					#if FM_CPU_X86
						DisplayMessageString(kErrorMsg, "Warning out of memory, please give more to FMP.\0", 23604);
					#else
						DisplayMessageString(kErrorMsg, "\pWarning out of memory, please give more to FMP.", 23604);
					#endif
						
					#if DEBUG_VERSION
							DisplayErrorNumber(kErrorMsg, mFerr, 23604);
					#endif
					
					mFerr = -108;
				}; // mFerr == 0
			
		}; // phdlSize < kDecryptedBufferMinSize  ||  phdlSize > kDecryptedBufferLSize
	}
	else
	{
			// The param is either too small, or two big, echo it back out to FMP (no loss of data)...
			FMX_LockHandle(param);
			ptrInsideParam = *param;
			
			FMX_SetHandleSize (result, phdlSize);
			mFerr = FMX_MemoryError();
			if ( mFerr == 0)
				{	// if no mem err, xfer param over to result...
					FMX_LockHandle(result);
					ptrInsideResult = *result;
					
					BlockMoveData (ptrInsideParam, ptrInsideResult, phdlSize);
					boolStoreResult = 0;
					mFerr = 0;
					
					FMX_UnlockHandle(result);
				}
				else
				{
					// not even enough mem for moving param back over to result...
					boolStoreResult = -1;
					
					#if FM_CPU_X86
						DisplayMessageString(kErrorMsg, "Warning out of memory, please give more to FMP.\0", 23699);
					#else
						DisplayMessageString(kErrorMsg, "\pWarning out of memory, please give more to FMP.", 23699);
					#endif
						
					#if DEBUG_VERSION
							DisplayErrorNumber(kErrorMsg, mFerr, 23699);
					#endif
					
					mFerr = -108;
				};
			
			FMX_UnlockHandle(param);

	}; // phdlSize != 0   &&  gCryptKeyLen != 0

checkErrResultIgnore (boolStoreResult, mFerr, result);
} // encrypt_RC6



static void decrypt_RC6(FHandle param, FHandle result)
{
long phdlSize;
long rhdlSize;

unsigned long tempSize;

char boolStoreResult;
int mFerr;

unsigned char *ptrInsideParam;
unsigned char *ptrInsideResult;

long blockHSizeChunks;
int	chunkSize;
unsigned long loopChunks;

// rc6_t rc6Key;


boolStoreResult = 0;
mFerr = 0;
tempSize = 0;

phdlSize = FMX_GetHandleSize(param);
if ((phdlSize != 0) && (gCryptKeyLen != 0))
	{
	if ((phdlSize < kDecryptedBufferMinSize) || (phdlSize > kEncryptedBufferLSize))
		{
			// The param is either too small, or two big, echo it back out to FMP (no loss of data)...
			FMX_LockHandle(param);
			ptrInsideParam = *param;
			
			FMX_SetHandleSize (result, phdlSize);
			mFerr = FMX_MemoryError();
			if ( mFerr == 0)
				{	// if no mem err, xfer param over to result...
					FMX_LockHandle(result);
					ptrInsideResult = *result;
					
					BlockMoveData (ptrInsideParam, ptrInsideResult, phdlSize);
					boolStoreResult = 0;
					mFerr = 0;
					
					FMX_UnlockHandle(result);
				}
				else
				{
					// not even enough mem for moving param back over to result...
					boolStoreResult = -1;
					
					#if FM_CPU_X86
						DisplayMessageString(kErrorMsg, "Warning out of memory, please give more to FMP.\0", 23705);
					#else
						DisplayMessageString(kErrorMsg, "\pWarning out of memory, please give more to FMP.", 23705);
					#endif
						
					#if DEBUG_VERSION
							DisplayErrorNumber(kErrorMsg, mFerr, 23705);
					#endif
					
					mFerr = -108;
				};
			
			FMX_UnlockHandle(param);
		}
		else
		{
			// The param is within the accepted size, decrypt it using the current key via the RC6 scheme...
			
			rhdlSize = (phdlSize >> 1); // decrypted param is twice as small as plaintext after hex encode...
			FMX_SetHandleSize (result, rhdlSize);
			mFerr = FMX_MemoryError();
			if ( mFerr == 0)
				{	// if no mem err, do the decryption...
					FMX_LockHandle(param);
					FMX_LockHandle(result);
					ptrInsideParam = *param;
					ptrInsideResult = *result;
					
					// unencode hex into plaintext...
					crypto_HexToStr(ptrInsideParam, (unsigned long)phdlSize, ptrInsideResult, &tempSize);
		
					// Prepare our RC6 key...
					#if RC6_unopd
//						rc6_key(rc6Key, gCryptKey, gCryptKeyLen);
					#else
//						rc6_key(rc6Key, (unsigned long *)gCryptKey, gCryptKeyLen);					
					#endif

					ptrInsideParam = *param;
					ptrInsideResult = *result;

					// Loop through data and pass it in chunks to scheme...
					blockHSizeChunks = (rhdlSize >> kRC6ChunkSizeBits );
					for (loopChunks = 0; loopChunks < blockHSizeChunks; loopChunks++)
						{
							// Do the scheme
							 rc6_decrypt(rc6Key, (unsigned long *)(ptrInsideResult+(loopChunks << kRC6ChunkSizeBits)), (unsigned long *)(ptrInsideResult+(loopChunks << kRC6ChunkSizeBits)));
						};

					ptrInsideParam = *param;
					ptrInsideResult = *result;

					// ROTate/Obscure data, using the size of the key as the amount to rotate by...
					crypto_ROT(gCryptKeyLen, kROTdecode, (unsigned long)rhdlSize, ptrInsideResult);

					FMX_UnlockHandle(param);
					FMX_UnlockHandle(result);
					
					// The paranoid can uncomment this block for extra security   --  (not used for RC4)
					// FMX_LockHandle(gCryptBuffer);
					// zeroCleanMemory(*gCryptBuffer, gCryptBufferSize);
					// FMX_UnlockHandle(gCryptBuffer);
					
					boolStoreResult = 0;
					mFerr = 0;
				}
				else
				{
					// not even enough mem for moving param back over to result...
					boolStoreResult = -1;
					
					#if FM_CPU_X86
						DisplayMessageString(kErrorMsg, "Warning out of memory, please give more to FMP.\0", 23706);
					#else
						DisplayMessageString(kErrorMsg, "\pWarning out of memory, please give more to FMP.", 23706);
					#endif
						
					#if DEBUG_VERSION
							DisplayErrorNumber(kErrorMsg, mFerr, 23706);
					#endif
					
					mFerr = -108;
				}; // mFerr == 0
			
		}; // phdlSize < kDecryptedBufferMinSize  ||  phdlSize > kDecryptedBufferLSize
	}
	else
	{
			// The param is either too small, or two big, echo it back out to FMP (no loss of data)...
			FMX_LockHandle(param);
			ptrInsideParam = *param;
			
			FMX_SetHandleSize (result, phdlSize);
			mFerr = FMX_MemoryError();
			if ( mFerr == 0)
				{	// if no mem err, xfer param over to result...
					FMX_LockHandle(result);
					ptrInsideResult = *result;
					
					BlockMoveData (ptrInsideParam, ptrInsideResult, phdlSize);
					boolStoreResult = 0;
					mFerr = 0;
					
					FMX_UnlockHandle(result);
				}
				else
				{
					// not even enough mem for moving param back over to result...
					boolStoreResult = -1;
					
					#if FM_CPU_X86
						DisplayMessageString(kErrorMsg, "Warning out of memory, please give more to FMP.\0", 23799);
					#else
						DisplayMessageString(kErrorMsg, "\pWarning out of memory, please give more to FMP.", 23799);
					#endif
						
					#if DEBUG_VERSION
							DisplayErrorNumber(kErrorMsg, mFerr, 23799);
					#endif
					
					mFerr = -108;
				};
			
			FMX_UnlockHandle(param);

	}; // phdlSize != 0   &&  gCryptKeyLen != 0

checkErrResultIgnore (boolStoreResult, mFerr, result);
} // decrypt_RC6





