// << file description: >>
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

"Example" - Sample Plugin Project
		
 This source code file will create a FileMaker Pro plugin that contains an 
 assortment of usefull functions that can be utilized in database solutions.

 Copyright 1998  FileMaker, Inc.  All Rights Reserved.
 
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/


// << project header: >>
// 	= ===---------------------------------------------------------------------=== =
// 	Project Began   	: October 1997	
// 	Project Finished	: April 1998	
// 	Last Modification 	: November 1997 

//				NOTES	: This source file is based on the FMPlugIn.c file
//                        This file is formatted with a Monospaced 9pt font
// = ===----------------------------------------------------------------------=== =	


// << version info: >>
// 	= ===---------------------------------------------------------------------=== =

// 	Source Code of version 1.0v1 x1 										    
//     Change History:  													   
// 	1.0v1
//    	x1	10/27/97		- "createdDate" changed to 08/05/1997.  -(DLM)			   
// 			10/28/97		- Syntax errors corrected in whole doc.   -(DLM)
//		x2	11/28/97		- Added WhizBang feature.  -(DLM)			

// 	Features to implement in future: 										   
//     	- Variable Buffer	

// = ===----------------------------------------------------------------------=== =	


/*:::::::::::::::::::::::::::::   Includes   ::::::::::::::::::::::::::::::*/

#include "FMFlags.h"

#if FM_CPU_X86

	
	#if FM_MWERKS
		#include <Win32Headers.mch>
	#else
		#include <Windows.h>
	#endif
	#include <winreg.h>
	#include <winerror.h>
	#include <locale.h>
	#include <winuser.h>
	#include <stdio.h>
	
#else

	#include <Resources.h>
	#include <TextUtils.h>
	#include <A4Stuff.h>
	
	#include <Types.h>
	#include <Quickdraw.h>
	#include <Dialogs.h>
	#include <Palettes.h>
	#include <IntlResources.h>
	#include <Events.h>
	
	#include <OSUtils.h> // for date/time stuff....
	
	#include <Sound.h> // for SysBeep
	#include <Script.h> // for international compatible chars for decimal point, currency, etc...
	
	#include <folders.h> // for finding the prefs folder
	#include <files.h> // for creating/reading the prefs file
		
	#include <MacTypes.h> // for UInt8, etc...
	#include <Gestalt.h>
	//#include <Errors.h>
	#include <NameRegistry.h>
		
#endif

#include "FMExtern.h"

#include "project.h"
#include "resource.h"

#include "FMPlugin.h"


/*:::::::::::::::::::::::::   MAIN - Main Entry Point   ::::::::::::::::::::::::::*/
/* This is the entry point into a FileMaker plugin. You do not want to */
/* modify anything in this section.						               */

#ifdef __cplusplus
extern "C"
{
#endif

/* 68K entry point definition */
#if FM_CPU_68K
pascal void main(FMExternCallPtr pb);
pascal void main(FMExternCallPtr pb)
#else

/* PowerPC entry point definition */
#if FM_CPU_PPC
void __declspec(export) FMExternCallProc(FMExternCallPtr pb);
void __declspec(export) FMExternCallProc(FMExternCallPtr pb)

/* Windows entry point definition */
#else
void __declspec(dllexport) FMExternCallProc(FMExternCallPtr pb);
void __declspec(dllexport) FMExternCallProc(FMExternCallPtr pb)

#endif
#endif
{
	/* Setup code */
	#if !FM_CPU_X86
		short fmOriginalResPath = CurResFile();
		
		EnterCodeResource();
		pb_resourceID = pb->resourceID;
		UseResFile(pb_resourceID);
	#endif
	
		gFMExternCallPtr = pb;
		
	/* Message dispatcher */
		switch (pb->whichCall) {
			case kFMXT_Init:
				pb->result = Do_Init(pb->extnVersion);
				break;
			case kFMXT_Idle:
				Do_Idle(pb->unsafeCalls);
				break;
			case kFMXT_External:
				Do_External(pb->parm2, (FHandle)(pb->parm3), (FHandle)(pb->result));
				break;
			case kFMXT_Shutdown:
				Do_Shutdown();
				break;
			case kFMXT_DoAppPreferences:
				Do_AppPrefs();
				break;
		}
	/* Exit code */
	#if !FM_CPU_X86
		UseResFile(fmOriginalResPath);
		ExitCodeResource();
	#endif
} /* FMExternCallProc */

#ifdef __cplusplus
}
#endif







/*::::::::::::::::::   PlugIn Routines - START HERE  :::::::::::::::::::*/

/*  The input and result parms are	                                        */
/* Mac style handles that contain text. This means that numbers are also    */
/* represented as text. The result handle is always empty when these	    */
/* routines are called. Only manipulate the input and result parms using    */
/* the memory manager callback routines that are defined in FMExtern.h.	    */
/* On the Mac they will be real Macintosh handles, but you cannot depend    */
/* on which heap they may be located in. On the PC side these handles exist */
/* in FileMaker's memory manager pool and has no relation to anything	    */
/* called a HANDLE in the Win32 API's.									    */






#include "PrivPlug.c"

#include "SQA_ob.c"





#include "PubPlug.c"







// Recieved a message that some calc depends on one of the external functions in this plugin, so perform
//    the appropriate function and return the results back to FMP.
static void Do_External(long functionId, FHandle parameter, FHandle result) {

	switch (functionId) {
#if  DEBUG_VERSION
		case 0:
			DebugPlugin(parameter, result);  // not PluginVersion
			break;
#else		
		case 0:
			PluginVersion(parameter, result);
			break;
#endif



		#include "SelRouts.c"



		default:
#if FM_CPU_X86
				MessageBeep(0);
#else
				SysBeep(1);
#endif
	}; /* switch */
} /* Do_External */