/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

		"Example" Plugin Project - Header File

		Copyright 1998  FileMaker, Inc.  All Rights Reserved.

:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

/*:::::::::::::::::::::::::::::   Defines   ::::::::::::::::::::::::::::::*/

#include "project.h"

#define kVersionLength	k_LenProgramVersion
#define kVersionString	k_ProgramVersion

#if FM_CPU_X86
#define k_Reg_Path	k_RegistryPathValue
#define k_Reg_Key_Format	"prefs\0"   // place holder pref
#else
enum {
	kUnsupported 		= 0,
	kPDMMachine			= 1,
	kPCIMachine			= 2,
	kCommSlotMachine	= 3,
	kPCIComm2Machine 	= 4
};

enum {
	kPDMEnetROMBase	= 0x50f08000
};

enum {
//	gestaltPowerBookG3Series 		= 312,
	gestaltPowerBookG3SeriesFSTN 	= 314,
	gestaltiMac						= 406
//	gestaltPowerMacG3 				= 510
};

#endif

#define k_PlatformLength	k_PlatformLEN
#if FM_CPU_68K
#define k_Platform	k_Platform68K
#else
#if FM_CPU_PPC
#define k_Platform	k_PlatformPPC
#else
#define k_Platform	k_PlatformX86
#define true	1
#define false	0
#define Boolean char
#define nil 0
#define UInt32 unsigned long
#endif
#endif

#define k_maxSizeFormat	20 // for how big our format string / result can be


#include "SQA_ob.h"

/*:::::::::::::::::::::::::::::   Globals   ::::::::::::::::::::::::::::::*/

// (MAC ONLY) Several functions deal with resources, so we want to save the resource fork
//    id so that it is available to these functions.
static short pb_resourceID;

// Several of our functions deal with floating point numbers, so we need to get the
//    appropriate numeral separators.
static char decimalSepCH;  // for reals, in the USA this would be '.' as in "3.1415"
static char decimalSepMonCH; // for reals, monetary values
static char largeSepCH;    // for large numbers, in the USA this would be ","  as in "2,132,443"
static char largeSepMonCH;  //for large numbers, monetary values
                     
// This plugin has one function which has a format string.  When we first use the plugin
//   it needs to default to something.  We'll assume this function will be used for 
//   formatting a phone number (for our example, a US phone number.
static char	pref_formatString[(k_maxSizeFormat+2)];   // [0] will hold the size of the actual string

static unsigned char gCryptKey[kCryptKeyPSize];
#if RC6_unopd
	static int gCryptKeyLen;
#else
	static unsigned char gCryptKeyLen;
#endif

static FHandle gCryptBuffer;
static long gCryptBufferSize;

//static rc4_t rc4Key; Needs initialization each time we are about to en/decrypt
static rc6_t rc6Key; // can be initialized once, and used across en/decrypts...



/*:::::::::::::::::::::   Function defs  (forward declarations) ::::::::::::::::::::::*/

// "Private" Routines
static void DisplayErrorNumber(int messageid, int value, int debugStage);
static void DisplayMessageString(int messageid, unsigned char *msgString, int debugStage);

static void DebugPlugin(FHandle parameter, FHandle result);
static void PluginVersion(FHandle parameter, FHandle result);

static void writePrefs (void);

// return all data after the ParamNum(th) in a pipe-delim'd string contained in a (filemaker) handle...
static void getAllAfterParamNumber(FHandle complexParameters, short ParamNum, unsigned int maxReturnSize, unsigned char  *paramData, unsigned int *paramSize);
static void getParamByNumber(FHandle complexParameters, short ParamNum, unsigned int maxReturnSize, unsigned char  *paramData, unsigned int *paramSize);
static void getSlashParamByNumber(FHandle complexParameters, short ParamNum, unsigned int maxReturnSize, unsigned char  *paramData, unsigned int *paramSize);

static unsigned int fiveChToInt (unsigned char c1, unsigned char c2, unsigned char c3, unsigned char c4, unsigned char c5);
static long convertStringToSInt32 (unsigned char *theCstring, unsigned long maxStrSize);
static long strToLong (unsigned char *pasclStr);
static unsigned char threeChToOneCh (unsigned char c1, unsigned char c2, unsigned char c3);
static unsigned long lengthofCString ( unsigned char *sourceStr);

static void convertUInt8toHex (unsigned char *twoCharStr, unsigned char theByte);
static void convertHextoUInt8 (unsigned char *twoCharStr, unsigned char *theByte);
static void convertUInt32toStr (unsigned char charPad, unsigned long theLong, unsigned char *theString, unsigned char *theStrLen, unsigned char withNullTerm);
static void convertSInt32toStr (unsigned char charPad, long theLong, unsigned char *theString, unsigned char *theStrLen, unsigned char withNullTerm);
static unsigned long quickPower (unsigned long theBase, unsigned long toThePower);

static long zeroCleanMemory (unsigned char *ptrToClean, long sizeOfPtr);


// Common code for checking function result boolean (boolFileResult), if -1, then return the text representation
//		of macFerr, otherwise ignore result since it already contains the valid data result of the function
static void checkErrResultIgnore (char boolFileResult, int macFerr, FHandle result);

// Common code for checking function result boolean (boolFileResult), if -1, then return the text representation
//		of macFerr, otherwise return "1" into result
static void checkErrResult (char boolFileResult, int macFerr, FHandle result);

// Routines for getting the MAC (Machine Axxxxx Cxxxx -- ie the NIC address, not MACintosh)...
// 		Macintosh Ethernet routines based largely on examples from Rich Kubota
static unsigned char ByteSwapValue(unsigned char val);
static unsigned long getCPUEthernetType(void);
static unsigned char getBurnedInMAC(unsigned char *stringDest, long *newStringLen);

// GetVSN- Returns "an almost unique machine/user identifier" number based upon either the VSN of the C drive on 
//		Windows, and Ethernet MAC or the date/time of the creation of the system disk on MacOS.
static void getVSN(FHandle result);

static void storeCryptKey(FHandle param, FHandle result);

static void encrypt_RC4(FHandle param, FHandle result);
static void decrypt_RC4(FHandle param, FHandle result);


#if FM_CPU_X86
BOOL APIENTRY prefProc (HWND mydlg, UINT dlgMsg, WPARAM wparm, LONG lparm);
static void BlockMoveData(const void *source, void *dest, unsigned long amntcpy);
#endif



// "Public" Routines
static long Do_Init(short version);
static void Do_AppPrefs(void);
static void Do_External(long functionId, FHandle parameter, FHandle result);

static void Do_Shutdown(void);
static void Do_Idle(FChar unsafeCalls);

