


#include "SQA_ob.h"



// CONVERT STRING INTO LARGER ASCII EQUIV...
// ie... "mno"  = "6D6E6F"
static void crypto_StrToHex(unsigned char *theSource, unsigned long tSourceSize, unsigned char *theResult, unsigned long *tResultSize)
{
unsigned long tempCh;
for (tempCh = 0; tempCh < tSourceSize; tempCh++)
	{
		convertUInt8toHex ( (theResult+(tempCh*2)), theSource[tempCh]);
	};
*tResultSize = (tSourceSize * 2);
} // crypto_StrToHex



// CONVERT ASCII HEX INTO STRING EQUIV...
// ie... "6D6E6F" = "mno"
static void crypto_HexToStr(unsigned char *theSource, unsigned long tSourceSize, unsigned char *theResult, unsigned long *tResultSize)
{
unsigned long tempCh;
unsigned long tempSize;

tempSize = (tSourceSize >> 1); // the result will be 1/2 the size that of the source, so don't exceed those bounds!

for (tempCh = 0; tempCh < tempSize; tempCh++)
	{
		convertHextoUInt8 ( (theSource+(tempCh*2)), (theResult+tempCh));
	};
*tResultSize = tempSize;
} // crypto_HexToStr



// LAST DITCH ENCODE USING KEY_LEN SPECIFIC ROT (0-255 threshold)
//	rotDirection = 0 = ROT with LEN of key
//	rotDirection = 1 = UNROT with LEN of Key
static  void  crypto_ROT (unsigned char rotValue, unsigned char rotDirection,  unsigned long buffSize, unsigned char *buffer)
{
unsigned char charInQuestion;
unsigned long onCharacter;
unsigned char overflowValue;

if (rotDirection == kROTencode)
	{ // encode
	for (onCharacter = 0; onCharacter < buffSize; onCharacter++)
		{
			charInQuestion = *(buffer+onCharacter);
			
			if ( charInQuestion < rotValue)
				{ // if values will be smaller than 0, wrap them over to ..255
					charInQuestion = (unsigned char)(255-(rotValue-charInQuestion));
				}
				else
				{
					charInQuestion = (unsigned char)(charInQuestion-rotValue);
				};
				
			*(buffer+onCharacter) = charInQuestion;
		};
	}
	else
	{ // decode
	for (onCharacter = 0; onCharacter < buffSize; onCharacter++)
		{
			charInQuestion = *(buffer+onCharacter);
			
			if ( charInQuestion > (255-rotValue))
				{ // if values will exceed 255, wrap them over to 0..
					overflowValue = (unsigned char)(charInQuestion - (255-rotValue));
					charInQuestion = (unsigned char)(0 + overflowValue);
				}
				else
				{
					charInQuestion = (unsigned char)(charInQuestion+rotValue);
				};
				
			*(buffer+onCharacter) = charInQuestion;
		};
	}; // if (rotDirection == kROTencode)

} // crypto_ROT





// -=-=- "RC4 COMPATIBLE" -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// -=-=- "RC4 COMPATIBLE" -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// -=-=- "RC4 COMPATIBLE" -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

/*! \file rc4.h
    \brief Header file for RC4 stream cipher routines
	 \author Damien Miller <djm@mindrot.org> 	\version 0.0.0	 \date 1999	 
	 A simple implementation of the RC4 stream cipher, based on the
	 description given in _Bruce Schneier's_ "Applied Cryptography"
	 2nd edition.
    This code is licensed under the GNU GPL. Please see the file
    COPYING for details
	 \warning The name "RC4" is trademarked in the United States, you may need to use "RC4 compatible" or "ARC4"  (Alleged RC4).
*/
void rc4_key(rc4_t *r, unsigned char *key, int len)
{
	int t;
	
	for(r->i = 0; r->i < 256; r->i++)
		r->s[r->i] = r->i;

	r->j = 0;
	for(r->i = 0; r->i < 256; r->i++)
	{
		r->j = (r->j + r->s[r->i] + key[r->i % len]) % 256;
		t = r->s[r->i];
		r->s[r->i] = r->s[r->j];
		r->s[r->j] = t;
	}
	r->i = r->j = 0;
} //rc4_key

void rc4_crypt(rc4_t *r, unsigned char *plaintext, int len)
{
	int t;
	int c;

	c = 0;	
	while(c < len)
	{
		r->i = (r->i + 1) % 256;
		r->j = (r->j + r->s[r->i]) % 256;
		t = r->s[r->i];
		r->s[r->i] = r->s[r->j];
		r->s[r->j] = t;

		t = (r->s[r->i] + r->s[r->j]) % 256;

		plaintext[c] ^= r->s[t];
		c++;
	}
} // rc4_crypt

void rc4_getbytes(rc4_t *r, unsigned char *buffer, int len)
{
	int t;
	int c;

	c = 0;	
	while(c < len)
	{
		r->i = (r->i + 1) % 256;
		r->j = (r->j + r->s[r->i]) % 256;
		t = r->s[r->i];
		r->s[r->i] = r->s[r->j];
		r->s[r->j] = t;

		t = (r->s[r->i] + r->s[r->j]) % 256;
		
		buffer[c] = r->s[t];
		c++;
	}
}  //  rc4_getbytes




// -=-=- "RC6 COMPATIBLE" -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// -=-=- "RC6 COMPATIBLE" -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// -=-=- "RC6 COMPATIBLE" -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

/* This is an independent implementation of the encryption algorithm:   */
/*         RC6 by Ron Rivest and RSA Labs                               */
/* which is a candidate algorithm in the Advanced Encryption Standard   */
/* programme of the US National Institute of Standards and Technology.  */
/* Copyright in this implementation is held by Dr B R Gladman but I     */
/* hereby give permission for its free direct or derivative use subject */
/* to acknowledgment of its origin and compliance with any conditions   */
/* that the originators of the algorithm place on its exploitation.     */
/* Dr Brian Gladman (gladman@seven77.demon.co.uk) 14th January 1999     */
/* Timing data for RC6 (rc6.c)
128 bit key:
Key Setup:    1632 cycles
Encrypt:       270 cycles =    94.8 mbits/sec
Decrypt:       226 cycles =   113.3 mbits/sec
Mean:          248 cycles =   103.2 mbits/sec
*/

#define f_rnd(i,a,b,c,d)                    \
        u = ROTL(d * (d + d + 1), 5);       \
        t = ROTL(b * (b + b + 1), 5);       \
        a = ROTL(a ^ t, u) + l_key[i];      \
        c = ROTL(c ^ u, t) + l_key[i + 1];

#define i_rnd(i,a,b,c,d)                    \
        u = ROTL(d * (d + d + 1), 5);       \
        t = ROTL(b * (b + b + 1), 5);       \
        c = ROTR(c - l_key[i + 1], t) ^ u;  \
        a = ROTR(a - l_key[i], u) ^ t;


/* initialise the key schedule from the user supplied key   */
#if RC6_unopd
// RC6_unopd code based on public domain sample implementation by Salvo Salasio
static void rc6_key(rc6_t l_key, unsigned char *in_key, const unsigned int key_len)
{   
unsigned long  l[9]; // 8 or 9  (8.7)
int i, j, s, v;
unsigned int A, B, c;

c = (key_len + 3)/4;

l[c-1] = 0;
for (i = key_len - 1; i >= 0; i--)
	{
		l[i / 4] = (l[i / 4] << 8) + in_key[i];
	};
	
	
l_key[0] = 0xB7E15163; // P32
for (i = 1; i <= kRC6KeySize; i++)
	{
		l_key[i] = l_key[i - 1] + 0x9E3779B9; // Q32
	};
	
A = B = i = j = 0;

v = kRC6KeySize+1; // R24
if (c > v) 
	{
		v = c;
	};
v *= 3;

for (s = 1; s <= v; s++)
{
	A = l_key[i] = ROTL(l_key[i] + A + B, 3);
	B = l[j] = ROTL(l[j] + A + B, A + B);
	i = (i + 1) % (kRC6KeySize+1);
	j = (j + 1) % c;
};

} // rc6_key

#else
/*         RC6 by Ron Rivest and RSA Labs                               */
static void rc6_key(rc6_t l_key, unsigned long *in_key, const unsigned long key_len)
{   
unsigned long  i, j, k, a, b, l[9], t;
l_key[0] = 0xb7e15163;

    for(k = 1; k < 44; ++k)
        l_key[k] = l_key[k - 1] + 0x9e3779b9;

    for(k = 0; k < (key_len / 32); ++k)
        l[k] = in_key[k];

    t = (key_len / 32) - 1; // t = (key_len / 32);
    a = b = i = j = 0;

    for(k = 0; k < 132; ++k)
    {   
    	a = ROTL(l_key[i] + a + b, 3); 
    	b += a;
	b = ROTL(l[j] + b, b);
	l_key[i] = a; 
	l[j] = b;
	i = (i == 43 ? 0 : i + 1); // i = (i + 1) % 44;  
        j = (j == t ? 0 : j + 1);  // j = (j + 1) % t;
    }; // for
} // rc6_key

#endif



/* encrypt a block of text  */
static void rc6_encrypt(rc6_t l_key, const unsigned long *in_blk, unsigned long *out_blk)
{   
unsigned long  a,b,c,d,t,u;

    a = in_blk[0]; 
    b = in_blk[1] + l_key[0];
    c = in_blk[2]; 
    d = in_blk[3] + l_key[1];

    f_rnd( 2,a,b,c,d); 
    f_rnd( 4,b,c,d,a);
    f_rnd( 6,c,d,a,b); 
    f_rnd( 8,d,a,b,c);
    f_rnd(10,a,b,c,d); 
    f_rnd(12,b,c,d,a);
    f_rnd(14,c,d,a,b); 
    f_rnd(16,d,a,b,c);
    f_rnd(18,a,b,c,d); 
    f_rnd(20,b,c,d,a);
    f_rnd(22,c,d,a,b); 
    f_rnd(24,d,a,b,c);
    f_rnd(26,a,b,c,d); 
    f_rnd(28,b,c,d,a);
    f_rnd(30,c,d,a,b);
    f_rnd(32,d,a,b,c);
    f_rnd(34,a,b,c,d); 
    f_rnd(36,b,c,d,a);
    f_rnd(38,c,d,a,b); 
    f_rnd(40,d,a,b,c);

    out_blk[0] = a + l_key[42]; 
    out_blk[1] = b;
    out_blk[2] = c + l_key[43]; 
    out_blk[3] = d;
    
} // rc6_encrypt



/* decrypt a block of text  */
static void rc6_decrypt(rc6_t l_key, const unsigned long *in_blk, unsigned long *out_blk)
{   
unsigned long  a,b,c,d,t,u;

    d = in_blk[3]; 
    c = in_blk[2] - l_key[43]; 
    b = in_blk[1]; 
    a = in_blk[0] - l_key[42];

    i_rnd(40,d,a,b,c); 
    i_rnd(38,c,d,a,b);
    i_rnd(36,b,c,d,a); 
    i_rnd(34,a,b,c,d);
    i_rnd(32,d,a,b,c); 
    i_rnd(30,c,d,a,b);
    i_rnd(28,b,c,d,a); 
    i_rnd(26,a,b,c,d);
    i_rnd(24,d,a,b,c); 
    i_rnd(22,c,d,a,b);
    i_rnd(20,b,c,d,a); 
    i_rnd(18,a,b,c,d);
    i_rnd(16,d,a,b,c); 
    i_rnd(14,c,d,a,b);
    i_rnd(12,b,c,d,a); 
    i_rnd(10,a,b,c,d);
    i_rnd( 8,d,a,b,c); 
    i_rnd( 6,c,d,a,b);
    i_rnd( 4,b,c,d,a); 
    i_rnd( 2,a,b,c,d);

    out_blk[3] = d - l_key[1]; 
    out_blk[2] = c; 
    out_blk[1] = b - l_key[0]; 
    out_blk[0] = a; 
    
}// rc6_decrypt

